<?php
/* ********************************************************************
* Interleave
* Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
* Licensed under the GNU GPL. For full terms see http://www.gnu.org/
*
* This handles editing attributes
*
* Check http://www.interleave.nl/ for more information
*
* BUILD / RELEASE :: 7.0.20161227
*
**********************************************************************
*/
require_once "initiate.php";
require_once "adminfunctions.php";

$edit = false;
$new_value = false;

$identifier		= $_REQUEST['identifier'];
$attribute		= $_REQUEST['attribute'];
$entity			= $_REQUEST['entity'];
$value			= $_REQUEST['value'];
$ajaxhandler	= 'JS_attr_' . $_REQUEST['identifier']. '-' . $_REQUEST['attribute'] . '-' . $_REQUEST['entity'];
$coditor		= $_REQUEST['coditor'];
$search_attribs	= $_REQUEST['search_attribs'];

if ($_REQUEST['edit'] == 1) {
	$edit = true;
}

$value_set = false;
if (isset($_REQUEST['new_value'])) {
	$new_value	= $_REQUEST['new_value'];
	$value_set = true;
}
// ===========================================

$stop = false;

switch ($identifier) {
	case "module":
		if (!is_administrator()) {
			$stop = true;
		}
	break;
	case "user":
		if (CheckFunctionAccess("UserAdmin") <> "ok" && !is_administrator()) {
			$stop = true;
		}
	break;
	case "group":
		if (CheckFunctionAccess("UserAdmin") <> "ok" && !is_administrator()) {
			$stop = true;
		}
	break;
	case "flextable":
		MustBeAdmin();
	break;
	case "extrafield":
		if (!is_administrator()) {
			$stop = true;
		}
	break;
	case "template":
		if (!is_administrator()) {
			$stop = true;
		}
	break;
	case "file":
		// all ok
	break;
	case "system":
		if (!is_administrator()) {
			$stop  = true;
		}
	break;


}

if ($stop) {

	print "[error]";
	// do nothing
	EndHTML(false);

} elseif ($attribute == "") {
    ShowHeaders();
	MustBeAdmin();
	if ($_GET['ShowAdminMenu']) {

		AdminTabs();

	}
	require "attributedocumentation.php";
	print "<form id=\"sform\" method=\"get\" action=\"attrib-assist.php\">";
	print "<input type='hidden' name='ShowAdminMenu' value='" . htme($_GET['ShowAdminMenu']) . "'>";
	print "<input type='hidden' name='SkipMainNavigation' value='" . htme($_GET['SkipMainNavigation']) . "'>";

	print "<table><tr><td>Identifier</td><td>";
	print "<select onchange=\"document.getElementById('sform').submit();\" name=\"identifier\" id=\"JS_identifier\">";
	print "<option value=\"\">-</option>";
	foreach (db_GetFlatArray("SELECT identifier FROM CRMattributes GROUP BY identifier ORDER BY identifier") AS $id) {
		print "<option";
		if ($identifier == $id) print " selected";
		print ">" . htme($id) . "</option>";
	}
	print "</select></td></tr>";
	print "<tr><td>Entity</td><td>";
	print "<select onchange=\"document.getElementById('sform').submit();\" name=\"entity\" id=\"JS_entity\">";
	print "<option value=\"\">-</option>";
	foreach (db_GetFlatArray("SELECT entity FROM CRMattributes WHERE identifier='" . mres($identifier) . "' GROUP BY entity ORDER BY entity") AS $ent) {
		print "<option";
		if ($entity == $ent) print " selected";
		print ">" . htme($ent) . "</option>";
	}
	print "</select>";
	print "</td></tr></table>";

	if ($identifier != "" && $entity != "") {

		print "Search attributes: ";

		print "<input type=\"search\" class=\"search_input\" name=\"search_attribs\" id=\"JS_search_attribs\" onchange=\"document.getElementById('sform').submit();\" value=\"" . htme($search_attribs) . "\">";


		$sql = "SELECT attribute FROM CRMattributes WHERE entity='" . mres($entity) . "' AND identifier='" . mres($identifier) . "'";
		if ($search_attribs != "") {
			$sql .= " AND attribute LIKE '%" . mres($search_attribs) . "%'";
		}
		$attribs = db_GetFlatArray($sql);
		print "<table class=\"crm\"><thead><tr><th>Attribute</th><th>Value</th><th>Description</th></tr></thead>";
		print "<tbody>";

		foreach ($attribs AS $attrib) {
			$doc = $attrib;
			foreach ($atdocs AS $key => $value) {
				if (strstr($attrib, $key)) {
					$doc = $key;
				}
			}
			print "<tr><td>" . htme($attrib) . "</td><td>" . AttributeAjaxEditElement($identifier,$attrib,$entity) . "</td><td>" . $atdocs[$doc][1] . "</td></tr>";
		}
		print "</tbody>";
		print "</table>";
	}

	print "</form>";
	EndHTML(true);

} elseif ($identifier != "" && $attribute != "" && $entity != "") { // Edit specific

	$unique = randomstring(8);

	$value = GetAttribute($identifier, $attribute, $entity);
	if ($value_set) {
		SetAttribute($identifier, $attribute, $new_value, $entity);
		$value = $new_value;
	}

	if (!$edit) {
				print $printvalue;

		print AttributeAjaxEditElement($identifier, $attribute, $entity, true);

	} else {
		$arr = GetAttributeAllowedOptions($identifier, $attribute);

		$onclick = " onchange=\"refresh_contents_of_div('" . $ajaxhandler . "','attrib-assist.php', 'identifier=" . $identifier . "&attribute=" . $attribute . "&entity=" . $entity . "&save=1&new_value=' + encodeURIComponent(document.getElementById('JS_new_value" . $unique . "').value), true);\"";

		$onblur = " onblur=\"refresh_contents_of_div('" . $ajaxhandler . "','attrib-assist.php', 'identifier=" . $identifier . "&attribute=" . $attribute . "&entity=" . $entity . "&save=1&new_value=' + encodeURIComponent(document.getElementById('JS_new_value" . $unique . "').value), true);\"";

		$submit = $onclick . $onblur;

		//print "<form id=\"attribinlineajaxform" . $unique . "\" method=\"post\" onsubmit=\"return(false);\">";
		if (is_array($arr)) {

			print "<select " . $submit . " name='new_value" . $unique . "' id='JS_new_value" . $unique . "'>";
			foreach ($arr AS $option) {
				$ins = "";
				if ($value == $option) {
					$ins = " selected";
				}
				print "<option value=\"" . htme($option) . "\" " . $ins . ">" . htme($option) . "</option>";
			}
			print "</select>";

		} elseif (strstr($attribute, "HTML") && $coditor != 1) {

			//print "<a onclick=\"ReloadAjaxElement('" . $ajaxhandler . "','&coditor=1', true);\">[code]</a>";
			print "<textarea name='new_value" . $unique . "' id='JS_new_value" . $unique . "' cols=80 rows=5>" . htme($value) . "</textarea>";
			print make_html_editor("JS_new_value", false, false, true, "300", "95%");

		} elseif (((stristr($attribute, "text") && $coditor != 1) || $attribute == "ExtraSelectCondition") && $coditor != 1) {

			//print "<a onclick=\"ReloadAjaxElement('" . $ajaxhandler . "','&coditor=1', true);\">[code]</a>";
			print "<textarea name='new_value" . $unique . "' id='JS_new_value" . $unique ."' cols='80' rows='5'>" . htme($value) . "</textarea>";

		} elseif (substr($attribute, strlen($attribute) -3,3) == "PHP" || $coditor == 1) {


			if ($value != "{{none}}" && $value != "") {
				print ValidatePHPSyntax($value) . "<br>";
			}
			?>
			<script type="text/javascript" src="lib/editarea/edit_area/edit_area_full.js"></script>
			<script type="text/javascript">
			editAreaLoader.init({
				id : "JS_new_value"			// textarea id
				,start_highlight: true	// if start with highlight
				,allow_resize: "both"
				,syntax_selection_allow: "css,html,js,php"
				,word_wrap: true
				,allow_toggle: true
				,language: "en"
				,syntax: "php"
				,font_size: "9"
				,font_family: "monospace"

			});
			</script>
			<?php
			print "<textarea id='JS_new_value" . $unique . "' rows='15' cols='100' name='new_value" . $unique . "'>" . htme($value) . "</textarea>";

		} elseif (stristr($attribute, "numof")) {

			print "<input " . $submit . " type='text' name='new_value" . $unique . "' size='5' id='JS_new_value" . $unique . "' value='" . htme($value) . "'>";

		} elseif (stristr($attribute, "SecuritySubselectFor")) {

			print "<textarea " . $submit . " name='new_value" . $unique . "' rows='10' cols='100' id='JS_new_value" . $unique . "'>" . htme($value) . "</textarea>";


		} else {

			print "<input " . $submit . " type='text' class='enter2blur autosizeoninput' name='new_value" . $unique . "' id='JS_new_value" . $unique . "' value='" . htme($value) . "'>";

		}
		//print "</form>";

//		print "&nbsp;<a onclick=\"ReloadAjaxElement('" . $ajaxhandler . "','&save=1&new_value" . $unique . "=' + document.getElementById('JS_new_value" . $unique . "').value);\">[save]</a>";
	}
	EndHTML(false);

} else {

	print "[error 2]";
	EndHTML(false);
}


?>
