<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * audio.php : handles recording, converting and uploading audio snippets
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.0.20161227
 *
 **********************************************************************
*/

require 'initiate.php';
ShowHeaders();

$record = $_GET['record'];
$table  = $_GET['table'];

/* no queries on _GET and _POST below this line */

if (CheckTableRecordAccess($table, $record) == "ok") {

    print '<style>';
    print '

        #recording_time {
            position: absolute;
            right: 10px;
            top: 10px;
        }
        .audiorecordbutton {
            font-size: 36px;
            color: red;
        }
        #viz {
    		height: 80%;
    		width: 100%;
    		display: flex;
    		flex-direction: column;
    		justify-content: space-around;
    		align-items: center;
    	}
        #analyser {
            width: 200px;
            height: 40px;
            border: 1px solid #dddddd;
        }

    ';
    print '</style>';
    print '<input type="hidden" name="table" id="JS_table" value="' . htme($table) . '">';
    print '<input type="hidden" name="record" id="JS_record" value="' . htme($record) . '">';

    print '<a id="JS_startrecording" class="audiorecordbutton" onclick="startRecording(this);$(this).hide();$(\'#JS_stoprecording\').show();$(\'#analyser\').show();"><span class="fa fa-circle" aria-hidden="true"></span></a>&nbsp;';
    print '<a id="JS_stoprecording" class="audiorecordbutton hide_content" onclick="stopRecording(this);$(this).hide();$(\'#JS_startrecording\').show();$(\'#analyser\').hide();"><span class="fa fa-stop-circle-o" aria-hidden="true"></span></a>';
    print '<div id="viz">
		<canvas id="analyser" class="hide_content"></canvas>
	       </div>';

    print '<div id="log"></div>';

    print '<script src="lib/recordmp3js/js/jquery-1.11.0.min.js"></script>';
    print '<script src="lib/recordmp3js/recordmp3.js"></script>';
    print '<div id="recording_time">0h 0m 0s</div>';
}

EndHTML();

?>
