<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see http://www.gnu.org/
 *
 * This is the duedate notifier
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.0.20161227
 *
 **********************************************************************
 */

$skip_recalc = false;
$GLOBALS['CONFIGFILE'] = $GLOBALS['PATHTOINTERLEAVE'] . "config/config.inc.php";
if (is_array($argv)) {
	foreach ($argv AS $cmdlineargument) {
		if (substr($cmdlineargument,0,4) == "cfg=") {
				$cmdlineargument = str_replace("cfg=", "" , $cmdlineargument);
				if (is_file($cmdlineargument)) {
					$GLOBALS['CONFIGFILE'] = $cmdlineargument;
					//$GLOBALS['PATHTOINTERLEAVE'] = str_replace("config/config.inc.php", "", $cmdlineargument);
					//$GLOBALS['PATHTOINTERLEAVE'] = str_replace('config\config.inc.php', "", $GLOBALS['PATHTOINTERLEAVE']);
					print "Using config file " . $GLOBALS['CONFIGFILE'] . "\n";
					continue;
				} else {
					handle_error("Config file declaration is not correct. Fatal.");
				}
		} 
		if ($cmdlineargument == "--skip-recalc") {
			$skip_recalc = true;
		}
	}
}

$GLOBALS['CMDLINE'] = true;
$GLOBALS['CRON_ADMIN_LOGIN'] = true;
$GLOBALS['overriderepository'] = 0;
$GLOBALS['NIGHTLY_CRON'] = true;

$cl = false;

if ($given_password) {


} else {
		$cl = true;

		if ($argv[1] && $argv[1] != "-help" && $argv[1] != "--help" && $argv[1] != "help" && $argv[1] != "-h") {
			$GLOBALS['overriderepository'] = $argv[1];
		}

		if ($argv[2] && $argv[1] != "-help" && $argv[1] != "--help" && $argv[1] != "help" && $argv[1] != "-h") {
			$given_password = $argv[2];
		}
		if (!$given_password || (!is_numeric($_REQUEST['reposnr']) && $_REQUEST['reposnr'] != 0)) {
			print "\nUsage:\n";
			print "\t[reposnr] [cron-password] {cfg=/path/to/config.inc.php}\n";
			print "\nExample 1: (suitable for a basic Interleave installation)\n\n";
			print "\t/usr/bin/php /var/www/interleave/duedate-notify-cron.php 0 cron-password\n";
			print "\nExample 2:\n\n";
			print "\t/usr/bin/php /var/www/interleave/duedate-notify-cron.php 3 cron-password cfg=/opt/interleave_config/config.inc.php\n";
			print "\n";
			print "The cron-password can be set in the application (global system settings), setting CRONPASSWORD.\n\n";
			exit;
		}
}

if (!is_numeric($_REQUEST['reposnr'])) $_REQUEST['reposnr'] = "0";

require "initiate.php";

require_once $GLOBALS['PATHTOINTERLEAVE'] . "adminfunctions.php";
require_once $GLOBALS['PATHTOINTERLEAVE'] . "lib/class.phpmailer.php";

/* this function redirects the user to index.php if a _SERVER['REQUEST_URI'] is found */
CheckIfShell();

if ($given_password<>GetSetting("cronpassword")) {
	print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": Incorrect user authentication string for this repository (" . GetSetting("title") . "). Quitting.\n\n";
	log_msg("ERROR: Duedate-notify-cron.php was called with incorrect password. No notifications were submitted.");
	exit;
}

$GLOBALS['UC']['DateFormat'] = GetSetting("DateFormat");

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": START maintenance for repository " . GetSetting("title") . "\n";
print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": Running with admin account " . $GLOBALS['USERID'] . " (" . GetUserName($GLOBALS['USERID']) . ")\n";


// Check if we're ran via web or using the command line
if (!$cl) {
	// This is the web, issue a warning, we don't like this anymore
	log_msg("WARNING:: duedate-notify-cron.php was invoked using a web GET. This is deprecated, use the command line (CLI) instead.");
	print "<h4>WARNING: duedate-notify-cron.php was invoked using a web GET. This is deprecated, use the command line (CLI) instead.</h4>";
	print "<h4><pre>Syntax: /usb/bin/php /path/to/interleave/duedate-notify-cron.php [reposnr] [password] {cfg=/path/to/configfile.to.use}</pre></h4>";
	print "<pre>";
	
} 



$webhost = getenv("HOSTNAME");

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": Sudo to admin account " . $GLOBALS['USERID'] . " (" . GetUserName($GLOBALS['USERID']) . ")\n";

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": Running ANALYZE on all tables\n";
foreach ($GLOBALS['UC']['PersonalDataStructure'] AS $table => $props) {
	mcq("ANALYZE TABLE `CRM" . $props['name_in_database'] . "`");
}

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": " .  "Set folder sizes ...\n";
foreach (db_GetArray("SELECT folder, SUM(filesize) FROM CRMbinfiles WHERE folder>0 AND filesize > 0 GROUP BY folder ORDER BY folder DESC") AS $fol) {
	mcq("UPDATE CRMbinfiles SET filesize='" . $fol[1] . "' WHERE fileid='" . $fol[0] . "' AND filetype='{{{folder}}}'");
}

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": " .  "Creating thumbnails for newly added image files ...\n";
GenerateImageThumbnails("all", false, false);

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": " .  "Fetching image GPS coordinates ...\n";
IndexGPSCoordinates();

//print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": " .  "Running database upgrade ...\n";
//require_once "dbupgrade.php";
//PerformDatabaseMaintenance(true);

if (!$skip_recalc) {
	print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": " .  "Recalculating calculations ... \n";
	recalc_calculations("", true, false);
}

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": " .  "Running compression archiver...\n";
ProcessArchiving();
if (GetSetting("DevelopmentOrProduction") != "Development") {
	print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": " .  "Running file offloader...\n";
	OffloadFilesToDisk();
}

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": " .  "Daily rules...\n";
ProcessRulesForAllTablesHavingRulesWithCondition("run once a day");

$day = date('l'); // Monday .. Sunday

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": " .  "Run on " . $day . " rules ...\n";
ProcessRulesForAllTablesHavingRulesWithCondition("run on " . strtolower($day));

if ($day != "Sunday" && $day != "Saturday") {
	print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": " .  "Working day rules...\n";
	ProcessRulesForAllTablesHavingRulesWithCondition("run once every working day");
}
if ($day == "Monday") {
	ProcessRulesForAllTablesHavingRulesWithCondition("run on first day of the week");
}

if (date('d') == "01") {
	print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": " .  "First day of the month, running rules...\n";
	ProcessRulesForAllTablesHavingRulesWithCondition("run on first day of the month");
}

if (date('z') == "0") {
	print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": " .  "First day of the year, running rules...\n";
	ProcessRulesForAllTablesHavingRulesWithCondition("run on first day of the year");
}

/* 
	deze rules zouden helemaal niet op deze manier moeten worden gedraaid. ze zouden in de rules
	table in combinatie met een conditie "run once a day" moeten staan.
*/

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": Running days-before-rules....\n";
ProcessRulesForAllTablesHavingRulesWithCondition("[value] days before [field]");

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": Running days-after-rules....\n";
ProcessRulesForAllTablesHavingRulesWithCondition("[value] days after [field]");

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": Running must-be-after-rules....\n";
ProcessRulesForAllTablesHavingRulesWithCondition("[field] must be after [matchvalue]");

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": Running must-be-before-rules....\n";
ProcessRulesForAllTablesHavingRulesWithCondition("[field] must be before [matchvalue]");

/*
print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": Running must-be-higher-than-rules....\n";
ProcessRulesForAllTablesHavingRulesWithCondition("[field] must be higher than [matchvalue]");

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": Running must-be-lower-than--rules....\n";
ProcessRulesForAllTablesHavingRulesWithCondition("[field] must be lower than [matchvalue]");
*/

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": " .  "Logging statistics ...\n";
LogStats();

/* extract ascii data from MS Office and OpenDocument files (if they don't have data already) */
/* sometimes this causes out-of-memory errors. do this after all important stuff has been done */

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": " .  "Updating document metadata index ...\n";
ExtractIndexData(false, true);

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": " .  "Removing failed rules messages older than 1 week ...\n";
$sql = "DELETE FROM `CRMjournal` WHERE `CRMjournal`.`type`='rules' AND `CRMjournal`.`message` LIKE 'FAILED CONDITIONS%' AND `CRMjournal`.`timestamp_last_change` < DATE_SUB(CURDATE(), INTERVAL 1 WEEK)";
mcq($sql);

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": " .  "Removing passed rules messages older than 2 months ...\n";
$sql = "DELETE FROM `CRMjournal` WHERE `CRMjournal`.`type`='rules' AND `CRMjournal`.`message` LIKE 'PASSED CONDITIONS%' AND `CRMjournal`.`timestamp_last_change` < DATE_SUB(CURDATE(), INTERVAL 2 MONTH)";
mcq($sql);

/* create indices if needed - do this LAST */
print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": Check indices to create ... \n";
create_indices();

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": " .  "Done.\n";

UpdateSetting("TimestampLastDuedateCron", date('U'));

print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ": END maintenance for repository " . GetSetting("title") . "\n";

EndHTML(false);



?>