<?php
/* ********************************************************************
* Interleave
* Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
* Licensed under the GNU GPL. For full terms see http://www.gnu.org/
*
* This script contains record functions
*
* Check http://www.interleave.nl/ for more information
*
* BUILD / RELEASE :: 7.0.20161227
*
**********************************************************************
*/

function get_form_element($fqn, $value, $recordid, $classes=array(), $name_as_placeholder=false, $interactive_field_list_element=false, $parentlistid="") {

	//DA("GFE Called fqn " . $fqn . " value " . $value . " recordid " . $recordid . "", false);

	//$debuginfo = "get_form_element(fqn $fqn, val $value, recordid $recordid, classes $classes=array(), name_as_placeholder $name_as_placeholder, readonly $readonly, interactive $interactive_field_list_element, parentlistid $parentlistid)";

	//trace("get_form_element(fqn $fqn, val $value, recordid $recordid, classes $classes=array(), name_as_placeholder $name_as_placeholder=false, readonly $readonly=false, interactive $interactive_field_list_element=false, parentlistid $parentlistid=false)", true);

	/*

	Support for javascript refresh: all handled in get_elements_to_update_on_field_change called by record-ajax.php on update of a field

	FIXED: Refresh van een complete table bij het aanpassen van een ifield!
	TODO: ifields in files-tables lijken het niet te doen (zie admin => projecten)
	FIXED: het lijkt erop dat records soms 2x geinsrted worden, zie rfc's
	FIXED: has mismatch, not updated melding bij deleten diary entry (maar werkt wel)
	TODO: CheckForDoubleAdds
	FIXED: Alle calculations op een form herladen bij een update


	LET OP: bij een refresh wordt NIET meer het hele form meegestuurd maar alleen het veld dat is aangepast. Dit is anders en op een hoop
	plaatsen zal er uit de $_REQUEST array een en ander gepeuterd worden. Dit moet dus omgeschreven worden!

	RefreshByAjaxOnChangeOfField						YES method reload_element
	RepopulateByAjax									YES method reload_element
	Interactive_list_element							YES
	IFields												YES
	UsePlanningCalendar									YES

	Support for ajax functions/methods: all handled in record-ajax.php

	Formsubmit/Validate									YES method general_form_submit
	Autosave											YES general_element_change (ook multiselects nu)
	Validate											YES general_element_change or general_element_validate
	ValidateButtonClick									YES (validatie via oude js functie ValidateButtonClick)

	Support/checklist for field types

	diary												YES
	drop-down											YES
	drop-down (populate by code)						YES
	checkbox											YES
	textbox												YES
	text area											YES
	numeric												YES
	date												YES
	Button												YES
	SQL Query											YES
	Reference to FlexTable								YES
	User-list of all CRM-CTT users						YES
	List of all groups									YES
	comment												YES (incl. refresh)

	mail												YES
	hyperlink											YES
	date (iso)											YES
	date/time											YES
	User-list of administrative CRM-CTT users			REMOVED
	phone number										YES

	drop-down (multiselect)								YES (multiselect nog in make_select_box bouwen)
	drop-down (populate by code multiselect)			CHECK (werkt als bovenstaande gefixed is)
	SQL Query (multiselect)								REMOVED (werkt als bovenstaande gefixed is)
	Reference to FlexTable (multiselect)				YES (multiselect nog in get_reference_element bouwen, of misschien in make_select_box want dit IS geen ref)
	text area (rich text)								YES
	color												YES
	Users of profile << ALL PROFILES >>					YES

	*/

	global $lang;

	/* split fqn to find table and field */
	list ($table, $field) = explode("-", $fqn);

	/* set some initial vars */

	/* vars to hold onchange/onfocus/onblur/onkeyup/onkeydown actions, in TEXT */
	$javascript_onchange_calls = "";
	$javascript_onfocus_calls = "";
	$javascript_onblur_calls = "";
	$javascript_onkeyup_calls = "";
	$javascript_onkeydown_calls = "";

	/*
	   stuff in $extra will be added to the form element, e.g. placeholders. vars above will also be put in $extra, and %%PARSE%%
	   tag in resulting element will be replaced by what is in $extra
	*/
	$extra = "";

	/* when set, the field will be required (will be set later on, default is false) */
	$required = false;

	/* the read only flag */
	$readonly = false;

	/* if we don't want a label, it will be set to true later on */
	$no_label = false;

	/* initial setting for debug texts */
	$debuginfo = "";

	/* the variable which eventually will hold the output of this function */
	$formelement = "";

	/* color_by_option; if true, javascript will be added (onchange) to color the background of the field to the bgcolor of the option */
	$color_by_option = false;

	/* close the div; only when an enclosing div is used */
	$close_the_div = true;

	/* this is for backwards compatibility */
	if (!ipi($recordid)) {
		$recordid = "_new_";
	}

	/* set the $class array to the given $classes array */
	$class = $classes;

	/* determine the field field id */
	$field_id = str_replace("f", "", $field);

	/* get the field row, we need it because not everything is in the datastructure */
	//$extrafield = db_GetRow("SELECT * FROM `CRMextrafields` WHERE `CRMextrafields`.`id`='" . $field_id . "'");


		if ($value == "" && !ipi($recordid) && $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['relation_to'] == "users" && $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["defaultvalue"] == "") {

			/* it it's a ref to users, and there is no default value, set current user as value */
			$value = $GLOBALS['USERID'];

		} elseif ($value == "" && !ipi($recordid) && $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["defaultvalue"] != "") {

			/* check if this tag contains a @TODAY@ tag, if so, fix it and issue a warning */

			if (strpos($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["defaultvalue"], "@TODAY@") !== false) {
					$GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["defaultvalue"] = str_replace("@TODAY@", "@TODAYISO@", $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["defaultvalue"]);
					// log_msg("WARNING: Field " . $fqn . " uses TODAY tag for default value. For record, this should be TODAYISO.");
			}

			/* if there is a default value, use it */

			/*
					WATCH IT: ParseTemplateRecordData looks in the REQUEST for given fields of type refer (which is nasty but ok)
					and parses the default value against all parent records. So even if ParseTemplateRecordData is called with an
					empty recordid, this is still very nescessary in order to parse the value against the future parents of this record!
			*/

			$value = get_parsed_template_with_given_template($table, "", array(), "", false, "", $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["defaultvalue"], 'DEFAULTVALUE');

		} elseif ($value == "" && ipi($recordid) && $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["defaultvalue"] != "") {

			$value = get_parsed_template_with_given_template($table, $recordid, array(), "", false, "", $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["defaultvalue"], 'DEFAULTVALUE');

			/*
				let op: unescape il chars, en niet DS overschrijven. Kan onderste regel niet helemaal weg?
			*/
			$GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["defaultvalue"] = $value;
		}
		/* add old value to form, if it's not empty. currently not used */

		/*
		if ($value != "") {
			if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "date" || $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "datetime" || $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "date (iso)") {
				$formelement = '<input type="hidden" name="old-' . $fqn . '-' . $recordid . '" id="JS_old-' . $fqn . '-' . $recordid . '" value="' . htme(from_iso_datetime($value)) . '">';
			} else {
				$oldvalue = $value;
				if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "diary") {
					$oldvalue = db_GetValue("SELECT `CRM" . $GLOBALS['SystemDataStructure'][$table]['name_in_database'] . "`.`" . $GLOBALS['SystemDataStructure'][$table]["fields"][$field]['name_in_database'] . "` FROM `CRM" . $GLOBALS['SystemDataStructure'][$table]['name_in_database'] . "` WHERE `CRM" . $GLOBALS['SystemDataStructure'][$table]['name_in_database'] . "`.`" . $GLOBALS['SystemDataStructure'][$table]['primary'] . "`='" . $recordid . "'");
					//print "Oldvalue $oldvalue";
				}
				$formelement = '<input type="hidden" name="old-' . $fqn . '-' . $recordid . '" id="JS_old-' . $fqn . '-' . $recordid . '" value="' . htme($oldvalue) . '">';
			}
		}

		*/


		/* check if a field is required in the datastructure ["required"]. */
		if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["required"] == true) {

			/* next, check if this field had conditions on requirements */
			if (check_field_required_conditions ($fqn, $recordid)) {
				/* set required fleg */
				$required = true;
			}
		}

		/* if the attribute AutoSizeOnInput is set, add the class */
		if (($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["AutoSizeOnInput"] && count($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["options"]) == 0 && $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["relation_to"] == "") || ($interactive_field_list_element && $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["fieldtype"] != "date") ) {
			$class[] = "autosizeoninput";
		}

//JH 2016-10-27 +/- 60 regels not_allowed_to_change_once_set code weg


			/* loop through possible field types */
			if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['use_populator_function']) {

				/* the datastructure tells us to use a custom populator function. this is only in use for fields in
				   admin tables. function get_field_options supports this type, and will return the right options */

				$options = get_field_options($field, $table, $recordid, $value);

				/* call make_select_box to create a normal select box */
				$formelement .= make_select_box($fqn, $options, $value, false, $recordid);
				/* later on, add the color-by-option javascript */
				$color_by_option = true;

			} elseif ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['relation_to'] != "") {


				/* it's a "normal" reference field */
				$formelement .= make_reference_element($fqn, $recordid, $value, $interactive_field_list_element, $readonly);

				/* code duplication; make_reference_element checks the same */

				if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["formelementtype"] == "list" && !$interactive_field_list_element) {

					/* this means it's displayed as text, not a dropdown */

				} elseif (!$GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["multiselect"]) {

					/* later on, add the color-by-option javascript, but exclude miltiselect fields */
					$color_by_option = true;

				}

			} elseif ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "comment") {

				/* a comment field is actually a template */

				$formelement .= make_comment($fqn, $recordid, "ok");
				$class[] = "calculation";
				$no_label = true;

			} elseif (count($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['options']) > 0 || $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "SQL Query") {

				/* drop-downs of all variations except reference field and DS custom populated fields */

				if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "checkbox") {

					/* this is a select box with two values, to be displayed as a checkbox */

					$formelement .= make_checkbox($fqn, $value, true, $recordid, $interactive_field_list_element);

				} elseif ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['formelementtype'] == "checkbox" && !$GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['multiselect']) {

					/* this is a select box with several values to be displayed as a set of radio buttons */

					list($options_list, $added_classes) = get_selectfield_options($fqn, $recordid);
					$class = array_merge($class, $added_classes);
					$formelement .= make_radio_select($fqn, $options_list, $value, true, $recordid);

				} elseif ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "drop-down" || $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "SQL Query" ||  count($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['options']) > 0) {

					/* this is a select box. the get_selectfield_options function fetches the options */
					list($options_list, $added_classes) = get_selectfield_options($fqn, $recordid);
					$class = array_merge($class, $added_classes);

					if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['multiselect']) {

						/* and make_multiselect turns it into multiselect select or checkbox */

						$formelement .= make_multiselect($fqn, $options_list, $value, false, $recordid);

						$class[] = "multiselectelement";

					} else {

						/* and make_select_box turns it into a select box */
						$formelement .= make_select_box($fqn, $options_list, $value, false, $recordid);

						/* later on, add the color-by-option javascript */
						$color_by_option = true;

					}
				}


			} elseif ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "diary") {

				/* diary field. pass to make_diary */

				$formelement .= make_diary($fqn, $recordid, unserialize($value));

			} elseif ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "text area" || $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "text area (rich text)" || $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["multiline"] == true) {

				/* a text area, of a field marked as multiline in the datastructure */

				/* remove enter2blur, if set */
				$class = array_diff($class, array('enter2blur'));

				/* the size and with are stored in the field options */
				$columns = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['size_width'];
				$rows = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['size_height'];

				if (!ipi($rows)) $rows="8";
				if (!ipi($columns)) $columns="40";

				if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "text area (rich text)") {

					$formelement .= '<textarea %%PARSE%% id="JS_' . $fqn . '-' . $recordid . '" name="' . $fqn . '-' . $recordid . '" rows="70" cols="140">' . htme($value) . '</textarea>';
					$formelement .= make_html_editor("JS_" . $fqn . "-" . $recordid, "", "", true, $rows, "100%", $table, $recordid);

				} else {

					/* create text area */
					$formelement .= '<textarea %%PARSE%% id="JS_' . $fqn . '-' . $recordid . '" name="' . $fqn . '-' . $recordid . '" rows="' . $rows . '" cols="' . $columns . '">' . htme($value) . '</textarea>';
				}


			} elseif ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype'] == "text") {

				/* a normal text input element */

				$element_type = "text";
				$print_value_behind_field = false;

				if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "color") {

					$element_type = "color";
					$print_value_behind_field = true;

				} elseif ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldsubtype'] == "mail") {

					$element_type = "email";
				}

				$formelement .= '<input %%PARSE%% type="' . $element_type . '" id="JS_' . $fqn . '-' . $recordid . '" name="' . $fqn . '-' . $recordid . '" value="' . htme($value) . '">';

				if ($print_value_behind_field) {
					$formelement .= '&nbsp;' . htme($value);
				}
				//2015-06-04 Jeroen; deze links zouden er ook achter moeten staan wanneer het form readonly wordt weergegeven

				if ($value != '' && (!$interactive_field_list_element || ($interactive_field_list_element && $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['interactive-alwaysinline']))) {

					if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldsubtype'] == "mail") {

						$formelement .= '&nbsp;<a href="#" onclick="this.href=\'mailto:\' + $(\'#JS_' . $fqn . '-' . $recordid . '\').val();"><span class="fa fa-envelope"></span></a>';

					} elseif ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldsubtype'] == "link") {

						$formelement .= '&nbsp;<a href="#" onclick="window.open(fix_url($(\'#JS_' . $fqn . '-' . $recordid . '\').val())); return false;"><span class="fa fa-external-link"></span></a>';

					} elseif ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldsubtype'] == "tel") {

						$formelement .= '&nbsp;<a href="#" onclick="this.href=\'tel:\' + $(\'#JS_' . $fqn . '-' . $recordid . '\').val();"><span class="fa fa-phone"></span></a>';

					}
				}


			} elseif ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype'] == "number") {

				/* a numeric field. fetch attributes MaximumValue anf MinimumValue */


				/* create the element */
				/* DON'T USE TYPE=NUMBER : The browser trims ".00" off of it */

				$formelement .= '<input %%PARSE%% type="text" id="JS_' . $fqn . '-' . $recordid . '" name="' . $fqn . '-' . $recordid . '" value="' . htme($value) . '"';

				/* To re-enable if we ever use type='number' again

				$MaximumValue = GetAttribute("extrafield", "MaximumValue", $field_id);
				$MinimumValue = GetAttribute("extrafield", "MinimumValue", $field_id);

				if ($MinimumValue !== "") {
					$formelement .= ' min="' . htme($MinimumValue) . '"';
				}
				if ($MaximumValue != "") {
					$formelement .= ' max="' . htme($MaximumValue) . '"';
				}
				*/
				$formelement .= '>';

			} elseif ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype'] == "date") {
				//jeroen: dit is tevens datetime!


				/* TODO: dit zou eigenlijk ook een losse functie moeten zijn, voor de netheid. niet heel belangrijk */



				/* a date field. the datastructure is ISO-date only, the user is not */
				$UsePlanningCalendar = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["UsePlanningCalendar"];

				$StrToTimeCompatStartDateString = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["StrToTimeCompatStartDateString"];

				if ($StrToTimeCompatStartDateString != "") {
					$startmomentY = date('Y', strtotime($StrToTimeCompatStartDateString));
					$startmomentM = date('n', strtotime($StrToTimeCompatStartDateString)); //JH n ipv m om geen leading zero te krijgen
					$startmomentD = date('j', strtotime($StrToTimeCompatStartDateString)); //JH j ipv d om geen leading zero te krijgen
					if ($startmomentY != "" && $startmomentY != -1) { // Php <5.1.0 returns -1 on fail
						$GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = "$(document).ready(function() { $('#JS_" . $fqn . "-" . $recordid . "').datepicker('option', 'defaultDate', new Date(" . $startmomentY . "," . $startmomentM . "," . $startmomentD . "));});";
					}
				}
				if ($UsePlanningCalendar) {
					$formelement .= '<input %%PARSE%% type="text" value="' . htme(from_iso_datetime($value)) . '" id="JS_' . $fqn . '-' . $recordid . '" name="' . $fqn . '-' . $recordid . '">';
					$args = "";

					$function = "PopCalendarSelectDay";
					$value_for_function = $value;

					if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "date/time") {
						$function = "PopCalendarSelectDayAndTime";
						if ($value_for_function == "" || $value_for_function == "0000-00-00 00:00:00") {
							$value_for_function = date('Y-m-d 12:00:00');
						}
					} else {
						if ($value_for_function == "" || $value_for_function == "0000-00-00") {
							$value_for_function = date('Y-m-d');
						}
					}

					$formelement .= '&nbsp;<div class="showinline" ><a onclick="' . $function . '(\'' . $field_id . '\',\'' . $recordid . '\',\'' . $value_for_function . '\',\'' . $args . '\');"><span class="fa fa-calendar"></span></a></div>';

					/*

					PopCalendarSelectDay(fieldnum, recordnum, curval, args)

					*/



				} else {
					$formelement .= '<input %%PARSE%% type="text" id="JS_' . $fqn . '-' . $recordid . '" name="' . $fqn . '-' . $recordid . '" value="' . htme(from_iso_datetime($value)) . '">';

					$formelement .= ' <a><label for="JS_' . $fqn . '-' . $recordid . '"><span class="fa fa-calendar"></span></label></a>';

					if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "date/time") {
						/* add datetimepicker class so the client will render the date picker on focus */
						$class[] = "datetimepicker";
					} else {
						/* add datepicker class so the client will render the date picker on focus */
						$class[] = "datepicker";
					}
				}
			} elseif ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "Button") {

					$formelement = make_button($table . "-" . $field, $recordid, "ok");
					$no_label = true;

			} else {

				/* catch-all default, the type is unknown */

				$formelement = htme($value) . " (type [" . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype'] . "] unknown (ef [" . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] . "]))";

			}

		/* check to see if the placeholder needs to be set */
		$Placeholder = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["Placeholder"];
		if ($Placeholder != "") {
			/* if a custom placeholder is set, use it */
			$extra .= ' placeholder="' . htme($Placeholder) . '"';
		} elseif ($name_as_placeholder) {
			/* else, if this function was called with name_as_placeholder = true, place the field name as the placeholder (interactive fields) */
			$extra .= ' placeholder="' . htme($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["name"]) . '"';
		}


		/* if the field has size settings, put them in the extra var */
		if (is_numeric($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['size_width']) && $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['relation_to'] == "" &&  count($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['options']) == 0 && $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] != "SQL Query" && $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] != "date" && $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] != "date/time" && $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] != "date (iso)" && $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] != "text area" &&   $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] != "text area (rich text)") {

			$size = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['size_width'];

			if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "color") {
				$size = 9;
			}

			if (ipi($size)) {
				$extra  .= ' size="' . $size . '" ';
			}

		} elseif ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['relation_to'] == "fields" || $field == "field") { /* ouch */

			/* put in a max with for field drop-downdowns. they get waaaay too big */
			$extra .= ' style="max-width: 250px;"';
		}

		/* add maximum, when set */
		if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype'] == "text") {
			$max_length = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["MaximumLength"];
			if (ipi($max_length)) {
				$extra .= " maxlength=\"" . $max_length . "\" ";
			}
		}



		/* the general change event */

		if ($interactive_field_list_element) {

			$reload_list = "1";
			if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["InteractiveDontReloadListOnChange"]) {
				$reload_list = "0";
			}

			/* interactive fields require to be hidden after a successful change */
			if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "checkbox" || $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['interactive-alwaysinline']) {


				/* if it's always visible */
				$javascript_onchange_calls .= " general_ifield_change('" . $fqn . "-" . $recordid . "','" . $recordid . "', this.value, '', '" . $parentlistid . "', " . $reload_list . ");";


			} else {

				/* if it's only visible when clicked */

				if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["fieldtype"] == "date") {

					/* datepicker and datetimepicker immediately blur the element when they show up. no unblur events it is */

					$javascript_onchange_calls .= " general_ifield_change('" . $fqn . "-" . $recordid . "','" . $recordid . "', this.value, '', '" . $parentlistid . "', " . $reload_list . ");";
					$javascript_onblur_calls = "";

				} elseif ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "text area (rich text)") {

					/* rich text WYSIWYG fields need a save button when used interactively */

					$button_onclick_calls = "CKEDITOR.instances['JS_" . $table . "-" . $field . "-" . $recordid . "'].updateElement();";
					$button_onclick_calls .= " general_ifield_change('" . $fqn . "-" . $recordid . "','" . $recordid . "', this.value, '', '" . $parentlistid . "', " . $reload_list . ");";


					$formelement .= '<button onclick="' . $button_onclick_calls . '">' . $lang['save'] . '</button>';

				} else {

					/* normal use onchange to trigger a blur, bind events on blur */

					$javascript_onchange_calls .= " this.blur();";
					$javascript_onblur_calls .= " general_ifield_change('" . $fqn . "-" . $recordid . "','" . $recordid . "', this.value, '', '" . $parentlistid . "'," . $reload_list . ");";
				}
			}

			/* only add enter2blur on !multiline fields */
			if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] != "text area" && $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] != "text area (rich text)" && !$GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["multiline"]) {

				/* might be already set in get_add_row_for_list */
				if (!in_array("enter2blur", $class)) {
					$class[] = "enter2blur";
				}
			}

			/* the autosizeoninput class */
			if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["AutoSizeOnInput"] && count($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["options"]) == 0 && $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["relation_to"] == "" && $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["fieldtype"] != "date") {
				$class[] = "autosizeoninput";
			}

		} else {

			/* this call kicks the ajax validate and autosave */
			$javascript_onchange_calls .= "general_element_change('" .  $fqn . "-" . $recordid . "','" . $recordid . "');";
		}

		/* put the classes in the extra var */
		$extra .= ' class="' . implode(" ", $class) . '"';

		/* if set, we color the field background to the color of the option */
		if ($color_by_option) {
			$javascript_onkeyup_calls .= " this.style.backgroundColor=this.options[this.selectedIndex].style.backgroundColor;";
			$javascript_onchange_calls .= " this.style.backgroundColor=this.options[this.selectedIndex].style.backgroundColor;";
			$javascript_onkeyup_calls .= " this.style.color=this.options[this.selectedIndex].style.color;";
			$javascript_onchange_calls .= " this.style.color=this.options[this.selectedIndex].style.color;";
		}

		/* the text to popup on every change except to '' */
		$ChangeAlertMessage = GetAttribute("extrafield", "ChangeAlertMessage", $field_id);
		if ($ChangeAlertMessage != '') {
			$javascript_onchange_calls = "if ($(this).val() != '') {alert('" . inline_jsencode(html2plaintext(ParseTemplateLanguageTags($ChangeAlertMessage))) . "');}" . $javascript_onchange_calls;
		}

//		$javascript_onkeyup_calls .= "";

		/* add the javascript calls to the extra var */

		/* onchange: all calls for saving/updating a value */
		if ($javascript_onchange_calls != "") {
			$extra .= " onchange=\"" . $javascript_onchange_calls . "\"";
		}
		/* onfocus: currently not in use */
		if ($javascript_onfocus_calls != "") {
			$extra .= " onfocus=\"" . $javascript_onfocus_calls . "\"";
		}
		/* onblur is primarily used for interactive fields */
		if ($javascript_onblur_calls != "") {
			$extra .= " onblur=\"" . $javascript_onblur_calls . "\"";
		}
		/* onkeyup: only in use for $color_by_option */
		if ($javascript_onkeyup_calls != "") {
			$extra .= " onkeyup=\"" . $javascript_onkeyup_calls . "\"";
		}
		/* onkeydown: currently not in use */
		if ($javascript_onkeydown_calls != "") {
			$extra .= " onkeydown=\"" . $javascript_onkeydown_calls . "\"";
		}

		$extra .= ' autocomplete="off"';

		/* put the extra var in the form element by replacing the %%PARSE%% tag */
		$formelement = str_replace("%%PARSE%%", $extra, $formelement);

		/* put the field value history icon behind the field, if set */
		if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["ShowFieldHistory"] == "Yes" && ipi($recordid)) {
			$formelement .= "&nbsp;<a onclick=\"PopFancyBoxLarge('','index.php?nonavbar=1&amp;FieldHistory&amp;table=" . $table . "&amp;record=" . $recordid . "&amp;field=" . $field_id . "');\"><span class=\"fa fa-line-chart\"></span></a>";
		}

		/* put the formcomment behind the field, if set */
		if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['FormComment'] != "" && !$interactive_field_list_element) {

			$formelement .= '<div class="formcomment-inline" id="formcomment-f' . $field_id . '-inline">' . htme($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['FormComment']) . '</div> <div class="formcomment-tooltip" id="formcomment-f' . $field_id . '-tooltip" title="' . htme($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['FormComment']) . '"><span class="fa fa-info-circle"></span></div>';
		}

		/* check to see if the jsearch box needs to be displayed. TODO: check if this is actually a select element */
		if (
			(	$GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['showsearchbox'] == true
				&&
				$GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] != "Reference to FlexTable (multiselect)"
				&&
				$GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] != "drop-down (multiselect)"
				&&
					($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "drop-down"
					||
					$GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['relation_to'] != ""
					||
					$GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['use_populator_function']
					)
				)
			)
			{
			$formelement .= ' ' . ReturnDropDownSearchField("JS_" . $fqn . "-" . $recordid);
		} else {

			/* uncomment for debug */

			//$formelement .= 'field ' . $field . ' table ' . $table . ' ILE [' . $interactive_field_list_element . '] searchbox failed conditions EF table type [' . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] . '] relation to [' . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['relation_to'] . ']';
		}


		if (!$interactive_field_list_element && !$no_label ) {

			/* get the name-to-show of this field. can be multi-lingual */
			$fnamets = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['name'];

			$insert = "";
			if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "checkbox") {
				/* checkboxes use a hidden field and a display field prefixed with 'X' */
				$insert = "X";
			}
			/* put appropriate divs around the element if it's a normal field */
			$formelement = '<div class="formfieldlabel" id="formfieldlabel-' . $fqn . '-' . $recordid . '"><label for="JS_' . $insert . $fqn . '-' . $recordid . '">' . htme($fnamets) . '</label></div><div class="formfield">' . $formelement . '';
		} else {
			$close_the_div = false;
		}

		/* add asterisk if the field is required. do NOT use a class, because reloading by ajax will not update these classes */
		if ($required && !$interactive_field_list_element && !$readonly_because_set_and_not_changeable) {
			$formelement .= "&nbsp;*";
		}

		/* close div */
		if ($close_the_div) {
			$formelement .= '</div>';
		}

	/* return the prepared element */

	/* uncomment for more readability */
	//$formelement = str_replace(">", ">\n", $formelement);

	/* add edit link for inline edit mode */
	if ($GLOBALS['SesMem']['InlineEditMode_InlineLinks'] == "On" && is_administrator() && !$interactive_field_list_element && $GLOBALS['UC']['PersonalDataStructure'][$table]["datatable"]) {
		$formelement = "<div class=\"InlineEditModeDivContainer\"><div class=\"InlineEditModeDiv\"><a title='" . $fqn . "-" . $recordid . " " . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] . "' href='extrafields.php?editextrafield=" . $field_id . "&amp;req_url=" . base64_encode($_SERVER['REQUEST_URI']) . "&amp;tabletype=entity'><span class=\"fa fa-edit\"></span></a></div></div>" . $formelement;

		if ($debuginfo != '') $formelement .= unescape_interleave_characters(ParseTemplateGeneric("@INFO@" . $debuginfo . "@ENDINFO@"));
	}

	//trace($fqn);

	return $formelement;
}

function make_reference_element($fqn, $recordid, $value, $interactive_field_list_element) {
	global $lang;

	/*
		This function creates a form element for field which are a reference to another table.
		These fields can be displayed as select box, but also as text with icons for select-in-popup,
		delete-current-set-value and add-record-to-parent-table-and-select-it.
	*/

	list ($table, $field) = explode("-", $fqn);

	if ((!$GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['multiselect']) && (!is_positive_integer($value)))
	{
		$value = 0;
	}

	/* var to hold the result */
	$formelement = "";

	/* get the table to which the field refers. */
	$target_table = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["relation_to"];
	/*
		trace( "Field $field target $target_table ifle $interactive_field_list_element");
	*/


	/* check if the refer field should be displayed as text */
	if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["formelementtype"] == "list" && !$interactive_field_list_element) {

		/* selecting from child tables can need extra options, saved in atribute ListOptionsForParentTable */
		$ListOptionsForParentTable = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["ListOptionsForParentTable"];

		$tags_in_ListOptionsForParentTable = array();
		$tags_in_ListOptionsForParentTable[] = $table . "-" . $field; //we need to send the own currently selected field for selectvia list's to work
		if ($ListOptionsForParentTable != "")
		{
			//dit zijn te parsen tags; doorgaans staan die in de hiddenfilters; we hebben de huidige formulier waarden nodig om op de server deze tags te kunnen parsen (uit de GET) in ParseTemplateRecordData die wordt aangeroepen in make_query()
			foreach (get_tags($ListOptionsForParentTable) as $tag)
			{
				$parts = explode("-", $tag);
				/*if (count($parts) == 2)
				{
					$tags_in_ListOptionsForParentTable[] = $tag;
				}*/

				//zodat je ook een hiddenfilter kan leggen op een parent value van het geselecteerde veld (ndi-t14-f552)
				$first_part = $parts[0] . "-" . $parts[1];
				if (!in_array($first_part, $tags_in_ListOptionsForParentTable))
				{
					$tags_in_ListOptionsForParentTable[] = $first_part;
				}
			}
		}


		$popupsizecode = 3;
		$popup_func = "PopFancyBoxLarge";

		/* for the open-popup when selecting, we need to know the size of the popup to open. it is stored in table attribute PopUpSize */
		$popupsizecode = $GLOBALS['UC']['PersonalDataStructure'][$target_table]["open_records_in_popup_mainlist"];
		if ($popupsizecode < 1) {
			$popupsizecode = $GLOBALS['UC']['PersonalDataStructure'][$target_table]["open_records_in_popup_sublist"];
		}

		if ($popupsizecode == 1) {
			$popup_func = "PopFancyBoxSmall";
		} elseif ($popupsizecode == 2) {
			$popup_func = "PopFancyBox";
		} elseif ($popupsizecode == 4) {
			$popup_func = "PopFancyBoxExtraLarge";
		} elseif ($popupsizecode == 3) { // default
			$popupsizecode = 3;
			$popup_func = "PopFancyBoxLarge";
		}

		/* our field id */
		$realfieldid = "JS_" . $fqn . "-" . $recordid;

		/* setup of the main text and link to upper table */


		if ((!ipi($recordid)) && ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["required"]) && (!$GLOBALS['UC']['PersonalDataStructure'][$target_table]["allowed_to_add"])) {
			/* get options and check if there's only one option. if so, set it, only when the field is required and the record is new AND the user is not allowed to add records to this table */
			/* via check_if_only_one_record kijken we alleen of het er meer dan 1 is */
			$check_if_only_one_record = true;
			$options = select_refer_field_options($table, $field, $recordid, $check_if_only_one_record);

			if (count($options) == 1) {
				/* if the record is new, the field is required and the list has only one option, select it */
				$value = array_keys($options)[0];
			}
		}

		/* initals */
		$formelement = "";

		/* link to the current selected value */

//		$formelement .= "<a class=\"toparent" . $field . "\" onclick=\"ilor('record.php?no_deletes=1&amp;put_id_in_child=" . $fqn . "-" . $recordid . "&amp;table=" . $target_table . "&amp;record=' + $('#" . $realfieldid . "').val(),'" . $popupsizecode ."','','','')\" id='" . $realfieldid . "ts'>";

		$formelement .= "<a class=\"toparent" . $field . "\" onclick=\"ilor('" . htme($GLOBALS['UC']['PersonalDataStructure'][$target_table]["openlink"]) . "' + $('#" . $realfieldid . "').val() + '";
		//TODO: door ilor() laten doen ?
		if (!strstr($GLOBALS['UC']['PersonalDataStructure'][$target_table]["openlink"], "?"))
		{
			$formelement .= '?';
		}
		else
		{
			$formelement .= '&amp;';
		}
		$starttable = $_GET['starttable'];
		$startrecordid = $_GET['startrecordid'];
		if (($starttable == "") || (!is_positive_integer($startrecordid)))
		{
			$starttable = $table;
			$startrecordid = $recordid;
		}
		$formelement .= 'starttable=' . $starttable . '&amp;startrecordid=' . $startrecordid . '&amp;put_id_in_child=' . $fqn . "-" . $recordid . "','" . $popupsizecode . "','','','')\" id='" . $realfieldid . "ts'>";

		if ($value > 0) {
			/* the representation of the currently selected reference */
			$formelement .= htme(get_refer_layout_for_record_field($table, $field, $value));
		}
		$formelement .= "</a>";


		$formelement .= "<div class=\"flexreficons nwrp\" id=\"" . $realfieldid . "flexreficons\">";

		parse_str($ListOptionsForParentTable, $ListOptionsForParentTable_array);
		$selectvia = $ListOptionsForParentTable_array["selectvia"];
		$table_parts_selectvia = array();
		if ($selectvia != "")
		{
			$table_parts_selectvia = explode("-", $selectvia);
		}
		//selectvia not specified; we will construct it ourselves
		if (count($table_parts_selectvia) == 0)
		{
			$selectvia = $table . "-" . $field . "-" . $target_table . "-" . $GLOBALS['UC']['PersonalDataStructure'][$target_table]["primary"];
		}

		/* add select icon+link to form element */
		$formelement .= '<a onclick="' . $popup_func . '(\'\', \'list.php?childrecordid=' . $recordid . '&amp;nonavbar=1&amp;selectvia=' . $selectvia;

		$cnt = 0;
		//is dit nog nodig nu we ook al bovenstaande replaces doen? volgens mij is alleen het eigen currently selected veld nog nodig; de rest niet
		foreach ($tags_in_ListOptionsForParentTable as $tag)
		{
			if ($cnt > 0)
			{
				$formelement .= ' + \'';
			}
			$formelement .= '&amp;' . $tag . '=\' + $(\'#JS_' . $tag . '-' . $recordid . '\').val()';

			$cnt++;
		}
		$formelement .= ')" title="' . htme($lang["choose"] . " " . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["name"]) . '"><span class="fa fa-list-alt"></span></a> ';

//2016-10-24 addlink verborgen omdat die vermoedelijk weinig gebruikt wordt en om hiermee de keuze van een parent record makkelijker te maken
/*
		// check to see if the user can add records to the target table.
		if ($GLOBALS['UC']['PersonalDataStructure'][$target_table]["allowed_to_add"]) {

			// if so, check to see if we need to add something to the url (legacy)
			$InlineAddIconURLExtras = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["InlineAddIconURLExtras"];
			if ($InlineAddIconURLExtras != "") {
				$InlineAddIconURLExtras = "&amp;" . unescape_interleave_characters(ParseTemplateRecordData($InlineAddIconURLExtras, $table, $recordid));
			}

			// add "add" option to html

			$formelement .= "<a onclick='" . $popup_func . "(\"\",\"" . htme($GLOBALS['UC']['PersonalDataStructure'][$target_table]["addlink"]) . "&amp;put_id_in_child=" . $table . "-" . $field . "-" . $recordid . "&amp;nonavbar=1" . $InlineAddIconURLExtras . '")\'><span class="fa fa-plus"></span></a>';

		} else {
			// if not, still display it, though hidden, so everythings lines out
			$formelement .= '<span class="fa fa-plus" style="visibility: hidden"></span>';
		}
		$formelement .= ' ';
/*

		/* add remove-value option to html */
		if (!$GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['required'])
		{
			$formelement .= "<a id=\"blindrefdeleteicon". $realfieldid . "\" onclick=\"document.getElementById('" . $realfieldid . "').value=''; document.getElementById('" . $realfieldid . "ts').innerHTML=''; $('#" . $realfieldid . "').change(); document.getElementById('blindrefdeleteicon" . $realfieldid . "').style.display = 'none';\"";
			/* ... and hide it when appliccable (not a security thing only UI) */
			if ($value == 0) {
				$formelement .= " style=\"display: none;\"";
			}
			$formelement .= ' title="' . htme($lang["delete"]) . '"><span class="fa fa-times"></span></a>';
		}

		$formelement .= "</div>";

		/* complete the form element */
		$formelement .= "<input %%PARSE%% type='hidden' name='" . $fqn . '-' . $recordid . "' id='" . $realfieldid . "' value='" . $value . "'>";


	} else {

		/* the field needs to be displayed as a normal select box (the only option for admin tables and configurable for fields) */

		if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['relation_to'] == "users" && ($value == 0) && $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["defaultvalue"] == "") {

			/* legacy support. if a ref-to-user field doesn't contain a value, and no default is given, default to current user's id */
			$value = $GLOBALS['USERID'];

		}

		$options = select_refer_field_options($table, $field, $recordid);

		if (count($options) == 1 && $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["required"] && !ipi($recordid)) {

			/* if the record is new, the field is required and the list has only one option, select it */

			foreach ($options as $value => $name) {
				/* first element is now set in $value, quit. don't use index [0] because the array is associative */
				//unset($name);
				continue;
			}
		}

		if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['multiselect']) {

				/* and make_multiselect turns it into multiselect select or checkbox */

				$formelement .= make_multiselect($fqn, $options, $value, false, $recordid);

		} else {

			/* turn it into a form element, but only if there's something to choose */
			if (count($options) > 0 || $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["required"]) {

				/* use make_select_box to create the actual element */
				$formelement .= make_select_box($fqn, $options, $value, false, $recordid);

			} else {
//				$formelement .= 'dit is de uitzondering';
			}
		}


	}

	return $formelement;
}

function get_field_options($field, $table, $record, $value) {

	/*
	   this function is called when [table][fields][field][use_populator_function] is true. it checks
	   which field it is and runs a third function to actually fetch the options
	*/

	if ($field == "table" && ($table == "rules" || $table == "downloadrules")) {

		/* field "table" in CRMrules refers to tables */
		return get_tables_selector_options($table, $record, $value);

	} elseif ($field == "field" && ($table == "ruleconditions" || $table == "ruleactions" || $table == "ruleactionconditions")) {

		/* refers to a field */
		return get_fields_selector_options($table, $record, $value);

	} elseif ($field == "condition" && ($table == "ruleconditions" || $table == "ruleactionconditions")) {

		/* refers to a condition */
		return get_condition_types($table, $record, $value);

	} elseif ($field == "action" && $table == "ruleactions") {

		/* refers to an action */
		return get_rules_actions($table, $record, $value);

	} elseif ($field == "template" && $table == "ruleactions") {

		/* refers to a template */
		return get_templates_selector_options($table, $record, $value);

	} elseif ($field == "module_to_run" && $table == "ruleactions") {

		/* refers to a module */
		return get_modules_selector_options($table, $record, $value);

	} elseif ($field == "attach" && $table == "ruleactions") {

		/* attach-to-mail options */
		return get_rule_mail_attachment_selector_options($table, $record, $value);

	} elseif (($field == "ref_start_date_time" || $field == "ref_end_date_time") && $table == "calendars") {

		/* refers to a field, of type "date" reltion to ""*/
		return get_field_selector_options($table, $record, $value, "date", "", $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["required"]);

	} elseif ($field == "ref_organiser" && $table == "calendars") {

		/* refers to a field, of type "id" relation to "users"s */
		return get_field_selector_options($table, $record, $value, "id", "users", $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["required"]);

	} else {

		/* unknown, error */
		log_msg("ERROR: get_field_options called with unknown field " . $field);
		return array();

	}
}
function get_field_selector_options($table, $record, $value = "", $only_type = "", $only_relation = "", $required = false) {
	/*
		this function fetches options for select boxes. mostly used for admin fields
	*/
	$options = array();

	/* loop through tables in ds */
	foreach ($GLOBALS['UC']['PersonalDataStructure'] AS $table => $prop) {

		/* skip all tables except data tables */
		if ($prop['datatable']) {

			/* loop through it's fields */
			foreach ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"] AS $field => $fieldprop) {

				/* if it matches $only_type, or when $only_type is not set */
				if ($only_type == "" || ($fieldprop['fieldtype'] == $only_type)) {

					/* if it matches $only_relation, or when $only_relation is not set */
					if ($only_relation == "" || ($fieldprop['relation_to'] == $only_relation)) {

						/* always skip timestamp_last_change, deleted and recordid */
						if ($fieldprop['name_in_database'] != "timestamp_last_change" && $fieldprop['name_in_database'] != "recordid" && $fieldprop['name_in_database'] != "deleted") {

							/* add to results */
							$options[$table . "-" . $field] = $table . "-" . $field . ": " . $fieldprop['name'];
						}
					}
				}
			}
		}
	}
	return $options;
}

function get_tables_selector_options($table, $record, $value="") {
	/*
		returns options for fields referring to a table. only for rules.
	*/
	$result = array();

	/* for rules */
	$result["none"] = "None (generic actions only)";

	foreach ($GLOBALS['UC']['PersonalDataStructure'] AS $table => $prop) {
		if ($prop['datatable']) {
			/* only add datatables. not really nescessary; rules should work with any table but ok */
			$result[$table] = $table . ": " . $prop['plural'];
		}
	}
	/* add users and groups tables */
	$result['users'] = $GLOBALS['UC']['PersonalDataStructure']['users']['plural'];
	$result['groups'] = $GLOBALS['UC']['PersonalDataStructure']['groups']['plural'];

	return $result;
}

function get_modules_selector_options($table, $record, $value="") {
	/*
		returns options for fields referring to a module
	*/
	$options = array();
	$found = false;
	foreach (db_GetArray("SELECT `CRMmodules`.`mid`, `CRMmodules`.`module_name` FROM `CRMmodules` WHERE `CRMmodules`.`version_belonging_to` = '0'") AS $mod) {
		//this is a admin function, so no check on CheckModuleAccess
		$RunAsUser = GetAttribute("module", "RunAsUser", $mod['mid']);
		if (ipi($RunAsUser)) {
			$options[$mod['mid']] = $mod['mid'] . ": " . $mod['module_name'];
			if ($mod[$mid] == $value) {
				$found = true;
			}
		}
	}
	if (!$found && $value != "0") {
		$options[$value] = "WARNING: MODULE HAS NO RUN-AS SETTING: " . $value;
	}

	return $options;
}

function get_templates_selector_options($table, $record, $value="") {
	/*
		returns options for fields referring to a template
	*/
	$options = array();
	foreach (db_GetArray("SELECT `CRMtemplates`.`templateid`, `CRMtemplates`.`templatename` FROM `CRMtemplates` WHERE `CRMtemplates`.`templatetype` IN ('TEMPLATE_HTML', 'TEMPLATE_REPORT_PDF', 'TEMPLATE_XML') AND `CRMtemplates`.`version_belonging_to` = 0") AS $tem) {
		//this is a admin function, so no check on CheckTemplateAccess
		$options[$tem['templateid']] = $tem['templateid'] . ": " . $tem['templatename'];
	}
	return $options;
}

function get_rule_mail_attachment_selector_options($table, $record, $value="") {
	/*
		returns options for rules field what-to-attach
	*/
	$options = array('nothing' => "Don't attach any files","all files" => "Atach all files","files matching" => "Attach files matching [matchvalue]");
	foreach (db_GetArray("SELECT `CRMtemplates`.`templateid`, `CRMtemplates`.`templatename` FROM `CRMtemplates` WHERE `CRMtemplates`.`templatetype` IN ('TEMPLATE_REPORT_PDF', 'TEMPLATE_XML') AND `CRMtemplates`.`version_belonging_to` = 0") AS $tem) {
		//this is a admin function, so no check on CheckTemplateAccess
		$options[$tem['templateid']] = $tem['templateid'] . ": " . $tem['templatename'] . " (attach to mail only)";
		$options[$tem['templateid'] . "+all"] = $tem['templateid'] . ": " . $tem['templatename'] . " (attach to mail only and attach all record attachments)";
        $options[$tem['templateid'] . "+2"] = $tem['templateid'] . ": " . $tem['templatename'] . " (attach to mail and record)";
		$options[$tem['templateid'] . "+2+all"] = $tem['templateid'] . ": " . $tem['templatename'] . " (attach to mail and record and attach all record attachments)";
	}
	return $options;
}

function get_condition_types($table, $record, $value="") {
	/*
		returns condition types (rules only)
	*/
	$conditions = array('[record] must be changed','[record] must be added','[record] must be deleted','[field] must be changed','[field] must be [matchvalue]','[field] must not be [matchvalue]','[field] must contain [matchvalue]','[field] must not contain [matchvalue]','[field] must be higher than [matchvalue]','[field] must be lower than [matchvalue]','[field] must be before [matchvalue]','[field] must be after [matchvalue]','[field] must be pressed [button]', 'run once a day', 'run once every working day', 'run every minute', 'run every hour', 'run on first day of the month', 'run on first day of the week', 'run on first day of the year', 'run on sunday','run on monday','run on tuesday','run on wednesday','run on thursday','run on friday','run on saturday', 'an e-mail is received', '[value] days before [field]','[value] days after [field]', 'at the exact date and time in [field]', 'system generates warning', 'system generates error', 'admin action request by user', 'a user logs in', 'group of current user must be [value] (csv)','group of current user must not be [value] (csv)', 'user id must be [value] (csv)', 'user id must not be [value] (csv)');
	$result = array();

	/* option=value in this case */
	foreach ($conditions AS $condition) {
		$result[$condition] = $condition;
	}
	return $result;
}

function get_rules_actions($table, $record, $value="") {
	/*
		returns list of possible actions for a ruleaction
	*/
	$actions = array('mail to user(s) in [field]','mail to address in [field]','mail to address(es) in [value]','mail to user-id(s) in [value]', 'mail to group-id(s) in [value]', 'mail to address(es) in result of query in [value]', 'display template [template]','display report [template]','attach report [template]','delete','run module [module]','update value of [field] to [value]', 'add string [value] to [field]', 'increase [field] by [value]', 'decrease [field] by [value]','multiply [field] by [value]', 'recalculate [field]', 'recalculate current record', 'run query in [value]', 'update [field] to result of query in [value]');

	/* atomos specific SMS queue table. If it doesn't exist, don't show SMS option. this is a dirty hack */
	$sql = "SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = 'sms'";
	if (db_GetValue($sql) == "sms") {
		$sql = "SELECT TABLE_NAME FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'sms' AND TABLE_NAME = 'smsqueue' LIMIT 1";
		if (db_GetValue($sql) == "smsqueue") {
			$actions[] = 'sms to number in [field]';
			$actions[] = 'sms to number(s) in [value]';
		}
	}

	/* option=value in this case */
	$result = array("" => "-");
	foreach ($actions AS $action) {
		$result[$action] = $action;
	}
	return $result;
}

function get_fields_selector_options($table, $record, $value="", $only_types = "") {
	/*
		returns list of possible actions for a field that refers to a field
	*/

	// table is not important in this function, neither is record or value
	$options = array("-" => "-");
	$ruletable = "";

	/* the only way to find out if we're editing a business rule event beloniging to a rule *HACK* - we shouldn't read $_REQUEST here */
	/* if so, limit results to fields belonging to the chosen rule table */

	if ($table == "ruleconditions" || $table == "actionconditions" || $table == "ruleactionconditions") {

		if (ipi($record)) {
			/* existing record */

			if ($table == "ruleconditions" || $table == "actionconditions") {

				$rule = db_GetValue("SELECT rule FROM CRM" . $table . " WHERE id='" . $record . "'");
				$ruletable = db_GetValue("SELECT `CRMrules`.`table` FROM `CRMrules` WHERE `CRMrules`.`id`='" . mres($rule) . "'");

			} elseif ($table == "ruleactionconditions") {

				/* ruleactionconditions is another child down */
				$ruleaction = db_GetValue("SELECT ruleaction FROM CRMruleactionconditions WHERE id='" . $record . "'");

				$rule = db_GetValue("SELECT `CRMruleactions`.`rule` FROM `CRMruleactions` WHERE `CRMruleactions`.`id`='" . mres($ruleaction) . "'");

				$ruletable = db_GetValue("SELECT `CRMrules`.`table` FROM `CRMrules` WHERE `CRMrules`.`id`='" . mres($rule) . "'");

			}
		} else {
			/* new record */

			if (ipi($_REQUEST['ruleconditions-rule']) && $table == "ruleconditions") {

				/* ruleconditions have a direct reference to the rule id, given in the request, this is a NEW action */
				$ruletable = db_GetValue("SELECT `CRMrules`.`table` FROM `CRMrules` WHERE `CRMrules`.`id`='" . mres($_REQUEST['ruleconditions-rule']) . "'");

			} elseif (ipi($_REQUEST['ruleactions-rule']) && $table == "ruleactions") {

				/* ruleactions have a direct reference to the rule id, given in the request, this is a NEW action */
				$ruletable = db_GetValue("SELECT `CRMrules`.`table` FROM `CRMrules` WHERE `CRMrules`.`id`='" . mres($_REQUEST['ruleactions-rule']) . "'");

			} elseif (ipi($_REQUEST['ruleactionconditions-ruleaction']) && $table == "ruleactionconditions") {

				/* ruleactionconditions is another child down */
				$rule = db_GetValue("SELECT `CRMruleactions`.`rule` FROM `CRMruleactions` WHERE `CRMruleactions`.`id`='" . mres($_REQUEST['ruleactionconditions-ruleaction']) . "'");
				$ruletable = db_GetValue("SELECT `CRMrules`.`table` FROM `CRMrules` WHERE `CRMrules`.`id`='" . mres($rule) . "'");

			}
		}
	}
	/* end hack */


	/* cycle through datastructure table names */
	foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) AS $table) {

		/* check match to ruletable, or when not set, ignore it */
		if ($table == $ruletable || $ruletable == "") {

			/* cycle through all the fields in the datastructure */
			foreach ($GLOBALS['UC']['PersonalDataStructure'][$table]['allfields'] AS $f) {
				$tp = "";
				$el = explode("-", $f);

				/* walk through all secondary elements: the table */
				for ($x=0;$x<count($el);$x+=2) {
					$tp .= " - " . $GLOBALS['UC']['PersonalDataStructure'][$el[$x]]['plural'];

					/* check to see if this is a configured field (not a hardcoded field) */
					if (ipi(str_replace("f", "", $el[$x+1]))) {

						$eft = GetExtraFieldType(str_replace("f", "", $el[$x+1]));
						$eft = str_replace("Reference to FlexTable", "REF", $eft);
						$eft = str_replace("User-list of all CRM-CTT users", "REF", $eft);

						/* get the name of the field for display purposes */
						$name = GetExtraFieldName(str_replace("f", "", $el[$x+1]));

						$tp .= " - " . $name . " [" . $el[$x+1] . "] [" . $eft . "]";

					} else {
						/* it's a hardcoded field, just use the name */
						$tp .= " - " . $el[$x+1];
					}

				}
				/* add to options */
				$options[$f] = $tp;
			}
		}
	}
	return $options;
}


function make_comment($fqn, $recordid, $access="ok") {

	/*
		this function returns a field of type "comment"

		WARNING! This function is the only function which could be called directly from ParseTemplateRecordData instead
		of get_form_element.

	*/
	$html = "";

	list ($table, $field) = explode("-", $fqn);

	/* get properties from DS */
	$fileid = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["comment_template_id"];

	/* if it seems to refer to a template ... */
	if (ipi($fileid)) {

		/* ... get the template */
		$html = GetTemplate($fileid);
		$html = ParseTemplateLanguageTags($html);

		/* ... and parse it several ways */
		if ($access == "ok") {

			$html = StripROOnlyTags($html);

		} elseif ($access == "readonly") {

			$html = StripRWOnlyTags($html);

		}
		if (ipi($recordid)) {
			$html = StripNewOnlyTags($html);
		} else {
			$html = StripExistingOnlyTags($html);
		}
		$html = get_parsed_template_with_given_template($table, $recordid, array(), "", false, "", $html, 'TEMPLATE_HTML');

	}
	/* return whatever is in $html */
	/* class="calculation" removed */
	return '<div id="JS_' . $fqn . '-' . $recordid . '" class="">' . $html . '</div>';
}
function make_button($fqn, $recordid, $access) {
	/*
		this function returns html for a functioning button
	*/
	$html = "";
	/* we need language tags in this function */
	global $lang;

	list ($table, $field) = explode("-", $fqn);

	/* buttons are always fields, defined in extrafields table */
	$field_id = str_replace("f", "", $field);

	if (ipi($field_id)) {

		/* get field props */
		//$extrafield = db_GetRow("SELECT * FROM `CRMextrafields` WHERE `CRMextrafields`.`id`='" . $field_id . "'");

		/* do we need a confirmation dialog? */
		$ButtonClickConfirmMessage = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["ButtonClickConfirmMessage"];

		/* check if there is a language tag */
		$buttonname = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['name'];
		if ($lang['EFID' . $field_id] != "") {
			$buttonname = $lang['EFID' . $field_id];
		}
		$insert1 = "";
		$insert2 = "";


		/* ValidateButtonClick does CLIENT-side validation: may the button be clicked? */
		$insert1 .= "if (ValidateButtonClick" . $field_id . "()) {";
		$insert2 .= "}";

		/* ButtonClickConfirmMessage. will be displayed last */
		if ($ButtonClickConfirmMessage != "") {

			$ButtonClickConfirmMessage = unescape_interleave_characters(ParseTemplateRecordData($ButtonClickConfirmMessage, $table, $recordid));

			$insert1 .= " if (confirm('" . inline_jsencode(html2plaintext($ButtonClickConfirmMessage)) . "')) { ";
			$insert2 .= "}";
		}

		/* parse the button name if it contains tags. TODO TE RUIME CHECK */
		if (strpos($buttonname, "@") !== false || strpos($buttonname, "%") !== false) {

			/* PTRD returns escaped values */
			$buttonname = unescape_interleave_characters(ParseTemplateRecordData($buttonname, $table, $recordid));
		}

		/* compose actual html */
		$html .= '<input type="button" value="' . htme($buttonname) . '" name="' . $fqn . '-' . $recordid . '" id="JS_' . $fqn . '-' . $recordid . '" ';

		if ($access == "ok") {

			/* execute_button does SERVER-side validation: may the button be clicked? */
			$html .=' onclick="' . $insert1 . 'execute_button(this.name, \'' . $recordid . '\');' . $insert2 . '"';

		} else {
			$html .=' disabled';
		}
		$html .= '>';
	}

	return $html;
}
function make_diary($fqn, $recordid, $content) {
	/*
		this returns (html for) a diary element
	*/

	/* we need language tags */
	global $lang;
	list ($table, $field) = explode("-", $fqn);

	if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["AutoUpdateDiaryField"]) {

		/* this means the diary must auto-update */
		$seconds_refresh = 20;

		$autorefresh = 'window.setInterval(function(){';
		$autorefresh .= '	update_diary(\'' . $fqn . '-' . $recordid . '\', \'' . $recordid . '\', \'\', 0);';
		$autorefresh .= "}, " . ($seconds_refresh * 1000) . ");";

		$GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = $autorefresh;
	}


	$btntext = $lang['addtodiary'];
	if ($btntext == "") {
		$btntext = $lang['go'];
	}

	$html = '<textarea cols="90" rows="2" id="JS_' . $fqn . '-' . $recordid . '" name="' . $fqn . '-' . $recordid . '" class="diaryinputbox"></textarea>';

	/* the field to hold the commenthash (for updating/deleting entries) */
	$html .= '<input type="hidden" name="commenthash-' . $fqn . '-' . $recordid . '" id="JS_commenthash-' . $fqn . '-' . $recordid . '">';

	/* only show ajax update button if the record already exists. if the field is required, leave the button out so the form will submit */
	if (ipi($recordid) && !$GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["required"]) {
		$html .= ' <button type="button" onclick="update_diary(\'' . $fqn . '-' . $recordid . '\', \'' . $recordid . '\', $(\'#JS_' . $fqn . '-' . $recordid . '\').val(), $(\'#JS_commenthash-' . $fqn . '-' . $recordid . '\').val(), 0);">' . $btntext . '</button>';
	}

	$html .= '<div class="diarycontainer" id="diarycontent_' . $fqn . '-' . $recordid . '">';
	$html .= get_formatted_diary_table($fqn, $recordid, $content);
	//$html .= return_diary($content, "table");
	$html .= '</div>';

	return $html;
}
function get_formatted_diary_table($fqn, $recordid, $content) {
	global $lang;

	$content = array_reverse($content);
	$html = '<div class="horscrollouter"><div class="horscroll"><table class="diarytable">';

	/* process the $content array and display it */
	$rowcolor = 1;
	if (count($content) % 2) {//not even
		$rowcolor = 2;
	}

	foreach ($content AS $row) {
		if ($row[2]) {
			$date = TransformDate(date("d-m-Y", $row[0]));
			$date .= " " . date("H:i", $row[0]);

			$html .= "<tr class=\"diaryrowcolor" . $rowcolor . "\"><td class=\"diarycell diaryname\">" . htme(GetUserName($row[1])) . "</td><td class=\"diarycell diarydatetime\">" . $date . "</td><td class=\"diarycellcontent\">" . nl2br(htme($row[2])) . "</td>";

			if ((CheckFunctionAccess("AllowedToAlterDiaryContents") == "ok")  || (is_administrator())) {
				$commenthash = md5($row[0] . $row[1] . $row[2]);

				//$onclick_ins = "document.getElementById('JS_EFID" . $field . "').value=Base64.decode('" . base64_encode($row[2]) . "');";

				$html .= "<td class=\"diarycelldelete\">";
				$html .= '<a onclick="if (confirm(\'' . $lang["pbdelconf"] . '\')){ update_diary(\'' . $fqn . '-' . $recordid . '\', \'' . $recordid . '\', \'\', \'' . $commenthash . '\', 1);}">';
				$html .= '<span class="fa fa-times" title="Delete this diary entry"></span>';
				$html .= "</a>";
				$html .= "&nbsp;";
				$html .= '<a onclick="$(\'#JS_commenthash-' . $fqn . '-' . $recordid . '\').val(\'' . $commenthash . '\'); $(\'#JS_' . $fqn . '-' . $recordid . '\').val(Base64.decode(\'' . base64_encode($row[2]) . '\'));">';
				$html .= '<span class="fa fa-edit" title="Edit this diary entry"></span>';
				$html .= '</a>';
				$html .= "</td>";
			}
			$html .= "</tr>";

			if ($rowcolor == 1) {
				$rowcolor = 2;
			} else {
				$rowcolor = 1;
			}
		}
	}
	$html .= '</table></div></div>';
	return $html;
}
function make_radio_select($fqn, $array, $current_value, $value_is_displayvalue=false, $recordid) {
	/*
		returns html for a radio select combo
	*/

	/* split fqn */
	list ($table, $field) = explode("-", $fqn);

	/* initial values */
	$option_value = "";
	$option_name = "";

	/* start div */
	$html = '<div id="JS_' . $fqn . '-' . $recordid . '-radiodiv">';

	/* idcounter used for keeping ids unique */
	$idcounter = 0;

	/* cycle though $array as options */
	foreach ($array AS $option) {

		/* an option can be a single value, or an array like "id" => "displayvalue" */
		if (is_array($option)) {
			$option_value = $option[0];
			$option_name = $option[1];
		} else {
			$option_value = $option;
			$option_name = $option;
		}

		$idcounter++;

		/* compose element */
		$html .= '<input ';
		$html .= ($current_value == $option) ? 'checked ' : '';
		$html .= ' type="radio" id="JS_' . $fqn . '-' . $recordid . '-' . $idcounter . '" name="radio-' . $fqn . '-' . $recordid . '" value="' . htme($option_value) . '" onclick="$(\'#JS_' . $fqn . '-' . $recordid . '\').val(this.value); $(\'#JS_' . $fqn . '-' . $recordid . '\').trigger(\'change\');">';

		$html .= '&nbsp;<label for="JS_' . $fqn . '-' . $recordid . '-' . $idcounter . '"';

		/* check if there is a specific option class set */
		if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["optionclass"][$option_value] != "") {

			$html .= ' class="' . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["optionclass"][$option_value] . '"';

		/* check for option colors */
		} elseif (is_array($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$option_value])) {

			$html .= ' style="';
			if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$option_value]["background"] != "") {
				$html .= 'background-color: ' . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$option_value]["background"] . ';';
			}
			if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$option_value]["foreground"] != "") {
				$html .= 'color: ' . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$option_value]["foreground"] . ';';
			}
			$html .= '"';
		}
		$html .= '>' . htme($option_name) . '</label><br>';
	}
	/* close div */
	$html .= "</div>";

	/* add hidden element containing the actual value. we do this so we can treat all fields equally */
	$html .= '<input %%PARSE%% type="hidden" id="JS_' . $fqn . '-' . $recordid . '" name="' . $fqn . '-' . $recordid . '" value="' . htme($current_value) . '">';
	return $html;
}
function make_checkbox($fqn, $current_value, $value_is_displayvalue=false, $recordid, $interactive_field_list_element) {
	/* creates a checkbox */

	/* split fqn */
	list ($table, $field) = explode("-", $fqn);

	/* get the values from the DS */
	$unchecked_value = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["options"][0];
	$checked_value   = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["options"][1];
	$defaultvalue    = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["defaultvalue"];

	/* start div */
	$html = '<div id="JS_' . $fqn . '-' . $recordid . '-checkboxdiv" class="showinline">';

	/* create checkbox */
	$html .= '<input ';

	/* determine if the box is currently checked or not */
	if ($checked_value == $current_value || (!ipi($recordid) && $defaultvalue == $checked_value) ) {
		$html .= ' checked="checked" ';
		if (!ipi($recordid) && $defaultvalue == $checked_value) {
			$current_value = $checked_value;
		}
	}

	/* standard element stuff */
	$html .= 'type="checkbox" name="X' . $fqn . '-' . $recordid . '" id="JS_X' . $fqn . '-' . $recordid . '" value="' . htme($checked_value) . '" onclick=" document.getElementById(\'JS_' . $fqn . '-' . $recordid . '\').value = this.checked ? \'' . $checked_value . '\' : \'' . htme($unchecked_value) . '\'; $(\'#JS_' . $fqn . '-' . $recordid . '\').trigger(\'change\');">';

	/* add hidden element containing the actual value. we do this so we can treat all fields equally */
	$html .= '<input %%PARSE%% type="hidden" id="JS_' . $fqn . '-' . $recordid;
	$html .= '" name="' . $fqn . '-' . $recordid . '" value="' . htme($current_value) . '">';

	$html .= '</div>';

	/* close div */
	return $html;
}
function make_multiselect($fqn, $options, $current_value, $value_is_displayvalue=false, $recordid) {
	/*
		generates a multi-select series of checkboxes
		if $GLOBALS['SesMem']['mobile'] is set, use multiline select
	*/
    // trace("make_multiselect($fqn, $options, $current_value, $value_is_displayvalue=false, $recordid) {");

	/* the current value is actually a serialized php array, of which each value is base64-encoded (sigh!) */

	$currently_selected_b64 = unserialize($current_value);
	$currently_selected = array();
	foreach ($currently_selected_b64 AS $value_b64) {
		/* decode values and put into array */
		$currently_selected[] = base64_decode($value_b64);
	}


	/* create div */
	$html = '<div class="multiselect" id="JS_' . $fqn . '-' . $recordid . '-multiselect"><ul>';

	/* don't do this if we're mobile */
	if (!$GLOBALS['SesMem']['mobile']) {
		$count = 0;
		foreach ($options AS $value => $displayvalue) {

			if ($displayvalue == '') $displayvalue = $value;

			$html .= '<li><input %%PARSE%% type="checkbox" name="' . $fqn . '-' . $recordid . '[]" id="JS_' . $fqn . '-' . $recordid . '-' . $count . '-multiselect"';
			//JH 201606-20 cannot add class here because %%PARSE%% could add a class; this is not ideal
			/*
			$optionclass = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["optionclass"][$value];
			if ($optionclass != "")
			{
				$html .= ' class="' . $optionclass . '"';
			}
			else
			*/

//JH 2016-10-20 uitgezet want er werd een undeclared var table en field gebruikt (dat zouden gevuld moeten worden met de eerste 2 elementen van de fqn); niet gefixt want we missen deze functionaliteit blijkbaar niet
// HF op te lossen en aan te zetten door list($table, $field) = explode("-", $fqn);
/*
			if (is_array($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$value])) {
				$html .= ' style="';
				if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$value]["background"] != "") {
					$html .= 'background-color: ' . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$value]["background"] . ';';
				}
				if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$value]["foreground"] != "") {
					$html .= 'color: ' . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$value]["foreground"] . ';';
				}
				$html .= '"';
			}
*/

			$html .= ' value="' . htme($value) . '"';
			if (in_array($value, $currently_selected)) {
				$html .= ' checked';
			}
			$html .= '> <label for="JS_' . $fqn . '-' . $recordid . '-' . $count . '-multiselect">' . htme($displayvalue) . '</label></li>';

			$count++;
		}
	}
	/* close ul and div */
	$html .= '</ul></div>';
	return $html;
}

function make_select_box($fqn, $options, $current_value, $value_is_displayvalue=false, $recordid) {
	/* creates a normal select box */

	/* split fqn */
	list ($table, $field) = explode("-", $fqn);

	/* create element */
	$html = '<select %%PARSE%% id="JS_' . mres($fqn) . '-' . $recordid . '" name="' . mres($fqn) . '-' . $recordid . '"';
	//JH 201606-20 cannot add class here because %%PARSE%% could add a class; this is not ideal

	/* determine color for the WHOLE element */
	if (is_array($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$current_value])) {
		$html .= ' style="';
		if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$current_value]["background"] != "") {
			$html .= 'background-color: ' . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$current_value]["background"] . ';';
		}
		if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$current_value]["foreground"] != "") {
			$html .= 'color: ' . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$current_value]["foreground"] . ';';
		}
		$html .= '"';
	}
	$html .= '>';

	/* add empty option */
	$html .= '<option value=""></option>';

	/* cycle through options */
	foreach ($options AS $value => $display) {

		/* equalize value to displayvalue if needed */
		if ($value === "" || $value_is_displayvalue) $value = $display;

		$html .= '<option';

		/* add string cast to value - we don't want to compare in a numeric sense */
		if ((string) $current_value == (string) $value) {
			$html .= ' selected';
		}

		/* add option specific class if needed */
		if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["optionclass"][$value] != "") {

			$html .= ' class="' . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["optionclass"][$value] . '"';

		} elseif (is_array($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$value])) {

			/* add option specific colors if needed */
			$html .= ' style="';
			if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$value]["background"] != "") {
				$html .= 'background-color: ' . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$value]["background"] . ';';
			}
			if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$value]["foreground"] != "") {
				$html .= 'color: ' . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"]["IS"][$value]["foreground"] . ';';
			}
			$html .= '"';
		}
		$html .= ' value="' . htme($value) . '">' . htme($display) . '</option>';
	}
	/* close element */
	$html .= '</select>';
	return $html;
}

function parse_arrow_tag($template, $table, $recordid, $record) {
	/* parses the #ARROWS# tag */

	/* initial values */
	$btp = "";
	$prt = false;

	/* check if ARROWS tag is in the template */
	if (strpos($template, "#ARROWS#") !== false) {

		/* we can only place the arrows if whe have a (valid) dqs (direct query store) */
		if (ipi($_REQUEST['dqs']) && PopStashValue($_REQUEST['dqs']) != "") {

			/* fetch the last loaded list in the right order */
			$list_of_ids = db_GetFlatArray(PopStashValue($_REQUEST['dqs']));

			/* find out where we are at the moment */
			$curpos = @array_search($recordid, $list_of_ids);

			/* compose openlink */
			$url = htme($GLOBALS['UC']['PersonalDataStructure'][$table]["openlink"]);
			$after_url = "";
			if (!strstr($GLOBALS['UC']['PersonalDataStructure'][$table]["openlink"], "?")) {
				$after_url = "?";
			} else {
				$after_url = "&amp;";
			}
			/* ... and anything we should put behind url */
			$after_url .= "listid=" . htme($_REQUEST['listid']) . "&amp;fromlist=" . $_REQUEST['fromlist'] . "&amp;dqs=" . htme($_REQUEST['dqs']) . "&amp;nonavbar=" .  htme($_REQUEST['nonavbar']) . "&amp;AddInPopup=" .  htme($_REQUEST['AddInPopup']) . "&amp;ParentAjaxHandler=" .  htme($_REQUEST['ParentAjaxHandler']) . "";


			if ($curpos > 0) {

				/* not the start of the list */
				$btp .= "<a onclick='window.location.href=\"" . $url . $list_of_ids[$curpos-1] . $after_url . "\"'><span class=\"fa fa-arrow-left\"></span></a> ";
				$prt = true;

			} else {

				/* at start, disabled button */
				$btp .= "<span class=\"fa fa-arrow-left disabled\"></span> ";
				$prt = true;
			}

			$btp .= " ";

			if ($curpos < sizeof($list_of_ids)-1) {

				/* not at the end of the list */
				$btp .= "<a onclick='window.location.href=\"" . $url . $list_of_ids[$curpos+1] . $after_url . "\"'><span class=\"fa fa-arrow-right\"></span></a> ";
				$prt = true;

			} else {

				/* at end, disabled button */
				$btp .= "<span class=\"fa fa-arrow-right disabled\"></span>";
				$prt = true;
			}

			/* when succeeded, replace */
			if ($prt) {
				$template = str_replace("#ARROWS#", "<div id='nav-arrows'>" . $btp . "</div>", $template);
			}

		} else {

			/* replace with nothing */
			$template = str_replace("#ARROWS#", "", $template);

		}
	}
	return $template;
}

function check_field_required_conditions ($fqn, $recordid) {
	/* checks if a field is required based on requirement conditions*/

	/* initial */
	$fields_to_fetch = array();
	$result = true;

	/* split fqn */
	list($table, $field) = explode("-", $fqn);


	/*
	 * layout of a condition
	 *
	[requiredconditions] => Array
	(
		[0] => Array
			(
				[otherfield] => t7-f164
				[value] => Ja
				[mustbetrue] => 1
			)

	)

	*/

	/* copy conditions by reference for easy reading */
	$conditions = &$GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["requiredconditions"];

	if (count($conditions) > 0) {

		/* add conditions to fields-to-fetch for getrecord */
		foreach ($conditions AS $condition) {
			$fields_to_fetch[] = $condition["otherfield"];
		}

		if (count($fields_to_fetch) > 0) {

			/* get current record, but only the fields we really need */
			$current_record = getrecord($table, $recordid, false, false, $fields_to_fetch, true); // geen lock check

			foreach ($conditions AS $condition) {
				if (
					($condition["value"] == $current_record[$condition["otherfield"]] && !$condition["mustbetrue"])
					||
					($condition["value"] != $current_record[$condition["otherfield"]] && $condition["mustbetrue"])
					) {

					/* condition failed */
					$result = false;

				}
			}
		}
	}

	return $result;
}
function return_ifield($fqn, $target_recordid, $value, $listid = "", $is_reload = false, $skip_access_check = false) {
	/* returns an ifield */

	/* by default it's only the value, which needs to be clicked to make the form element appear. the alwaysinline field is displayed as a normal form element */

	$elements = explode("-", $fqn);
	$completepath = $fqn;

	if (count($elements) == 2) {

		/* split fqn */
		$target_table = $elements[0];
		$target_field = $elements[1];

	} else {

		$target_table = $elements[count($elements)-2];
		$target_field = $elements[count($elements)-1];
		$fqn = $target_table . '-' . $target_field;
	}

	/* split fqn */
//	list($target_table, $target_field) = explode("-", $fqn);

	/* initials */
	$textvalue = "";
	$result = "";

	/* create text value, but only if it's a default ifield */
	if (!$GLOBALS['UC']['PersonalDataStructure'][$target_table]["fields"][$target_field]['interactive-alwaysinline']) {

		if ($GLOBALS['UC']['PersonalDataStructure'][$target_table]["fields"][$target_field]['relation_to'] != "") {

			$textvalue = get_refer_layout_for_record($GLOBALS['UC']['PersonalDataStructure'][$target_table]["fields"][$target_field]['relation_to'], $value);

		} else {

			/* get the textual human readable value. it will be htme encoded when we get it back */
			$textvalue = formatvalue($value, $fqn);
		}
	}

	/* when an ifield gets reloaded, it's already in this div. don't print it again! */
	if (!$is_reload) {
		$result = '<div class="showinline ifield-enclosing-div" id="ifield-enclosing-div-' . $completepath . '">';
	}

	/* only put these divs around it if we're not in a list */
	if ($listid == "") {

		/* get the name-to-show of this field. can be multi-lingual */
		$fnamets = $GLOBALS['UC']['PersonalDataStructure'][$target_table]["fields"][$target_field]['name'];

		/* put appropriate divs around the element */
		$result .= '<div class="formfieldlabel" id="formfieldlabel-' . $fqn . '-' . $target_recordid . '" for="ifield-' . $fqn . '-' . $target_recordid . '"><label for="JS_';

		if ($GLOBALS['UC']['PersonalDataStructure'][$target_table]["fields"][$target_field]['fieldtype_in_extrafields_table'] == "checkbox") {

			/* checkboxes are prefixed, and an hidden field is added. the label is for the visible field */
			$result .= 'X';
		}

		$result .= '' . $fqn . '-' . $target_recordid . '">' . htme($fnamets) . '</label></div><div class="formfield">';

	}

	if ($GLOBALS['UC']['PersonalDataStructure'][$target_table]["fields"][$target_field]['interactive-alwaysinline']) {

		/* when interactive-alwaysinline is set, it means the form element should be displayed always */
		$result .= make_ifield($fqn, $target_recordid, $listid, $value, true, $skip_access_check);

	} else {

		/* nasty, but a non-permanently-interactive ifield must have some value in order to see the underline to be able to click it */
		if ($textvalue == "") $textvalue = "&nbsp;&nbsp;&nbsp;";

		/* enclose the tags with ifield-specific divs and the onclick handler */
		$result .= '<div class="ifield showinline" id="ifield-' . $fqn . '-' . $target_recordid . '"><span id="interactive_cell_' . $fqn . '-' . $target_recordid . '" class="interactive_cell" onclick="load_ifield(\'' . $fqn . '\',\'' . $target_recordid . '\', \'' . $listid . '\');">' . $textvalue . '</span>';

		$result .= '</div>';

		if ($value != '') {

			if ($GLOBALS['UC']['PersonalDataStructure'][$target_table]["fields"][$target_field]['fieldsubtype'] == "mail") {

				$result .= '&nbsp;<a href="#" onclick="this.href=\'mailto:\' + $(\'#interactive_cell_' . $fqn . '-' . $target_recordid . '\').html();"><span class="fa fa-envelope"></span></a>';

			} elseif ($GLOBALS['UC']['PersonalDataStructure'][$target_table]["fields"][$target_field]['fieldsubtype'] == "link") {

				$result .= '&nbsp;<a href="#" onclick="window.open(fix_url($(\'#interactive_cell_' . $fqn . '-' . $target_recordid . '\').html())); return false;"><span class="fa fa-external-link"></span></a>';

			} elseif ($GLOBALS['UC']['PersonalDataStructure'][$target_table]["fields"][$target_field]['fieldsubtype'] == "tel") {

				$result .= '&nbsp;<a href="#" onclick="this.href=\'tel:\' + $(\'#interactive_cell_' . $fqn . '-' . $target_recordid . '\').html();"><span class="fa fa-phone"></span></a>';

			}
		}

	}

	/* only close if not in a list */
	if ($listid == "") {
		$result .= '</div>';


	}
	if (!$is_reload) {
		$result .= "</div>";
	}
//	$result  = "return_ifield($completepath, $target_recordid, $value, $listid = \"\", $is_reload = false, $skip_access_check = false)" . $result;
	return $result;

}
function make_ifield($fqn, $recordid, $listid, $value = "", $value_given = false, $skip_access_check = false) {

	/* debug */
	$d = "";

	//$d = "make_ifield($fqn, $recordid, $listid, $value = \"\", $value_given = false, $skip_access_check = false";
	/*
		Accepts input like t1-f23

	*/

	/* initials */
	$current_record = array();

	if ($listid == "undefined") {
		$listid = "";
	}

	/* split fqn */
	list ($table, $field) = explode("-", $fqn);

	if (!$skip_access_check) {

		/* get the list of writeable fields. this returns field-names only, like f123, in an array */
		$current_record = getrecord($table, $recordid, false, false, array($fqn));
	}

	/* if a value was *not* given, fetch it */
	if (!$value_given) {

		/* get current record, but only the field we need */
		if ($skip_access_check) {
			/* we're sure we didn't do this already */
			$current_record = getrecord($table, $recordid, false, false, array($fqn));
		}
		$value = $current_record[$fqn];
	}

	if ($skip_access_check || ($current_record['type_of_access'] == 'ok' && $current_record['*' . $fqn] == 1)) {

		/* create the form element */
		$box = $d . get_form_element($fqn, $value, $recordid, false, true, true, $listid);

		if (!$listid) {

			/* add formcomments, again, only if we're not in a list */
			if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['FormComment'] != "") {

				$box .= '<div class="formcomment-inline" id="formcomment-' . $field . '-inline">' . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['FormComment'] . '</div> <div class="formcomment-tooltip" id="formcomment-' . $field . '-tooltip" title="' . htme($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['FormComment']) . '"><span class="fa fa-info-circle"></span></div>';

			}
		}

		return $box;

	} else {
		/* get current record, but only the field we need */

		if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["relation_to"] != "") {
			return $d . htme(get_refer_layout_for_record_field($table, $field, $value));
		} else {
			return $d . formatvalue($value, $fqn) . " access denied: " . $current_record['*' . $fqn];
		}
	}
}

function get_add_row_for_list_table($table, $listid, $columns, $prefill_fields = array(), $custom_extra_columns) {
	/*
		This function returns an html formatted table row, to be printed on top of any
		list table, to add an add-form.
	*/

	$prefill = array();
	$prefill_values = array();

	/* check prefills. prefills are based on (hidden)filters. excluded are numbers and dates, NOT-filters and filters with more than one selected option */

	/* VERY DIRTY: we save this prefill in a global. ParseTemplateRecordData needs this in order to pre-parse ListOptionsForParentTable. We should pass this as a function argument.
	 */
//	 DA($prefill_fields, false);
	$GLOBALS['prefill_fields'] = $prefill_fields;
	foreach ($prefill_fields AS $fqn => $value) {

		if (in_array($fqn, $columns)) {

			/* this is a normal, visible field. */
			$prefill_values[$fqn] = $value;

		} else {

			/* this is a non-visible field, add hidden */
			$prefill[$fqn] = $value;
		}
	}


	/* alias the DS for readability */
	$dst =& $GLOBALS['UC']['PersonalDataStructure'][$table];

	/* the var to hold the result */
	$row = '';

	/* check if the user has add-access for this table */
	if ($dst["allowed_to_add"]) {

		/* the button to be put at the and of all elements to submit the "form" which is not a form */
		$add_at_end = '&nbsp;<button onclick="
					if (general_form_submit(\'' . $table . '-' . $listid . '-inlineadd\', \'_new_\', false, \'' . $listid . '\')) {
						SubmitInlineForm(document.getElementById(\'' . $table . '-' . $listid . '-inlineadd\'), \'' . $listid . '\',\'_new_\');
						}
			" type="button">' . htme($dst['addlinktext']) . '</button>';

		/* add the table var, server side needs this */
		$add_at_end .= '<input type="hidden" name="table" value="' . $table . '">';

		/* hidden columns also add when checking if all required fields are in this form. this array holds them */
		$columns_hidden = array();

		/* walk through preset values. $prefill is given by list */
		foreach ($prefill AS $fqn => $value) {

			/* it's given, add it to add_at_end */
			$add_at_end .= '<input type="hidden" name="' . $fqn . '-_new_" id="JS_' . $fqn . '-_new_" value="' . $value . '">';

			/* and add it to the given hidden columns array */
			$columns_hidden[] = $fqn;
		}

		/* array to hold missing but required fields */
		$missing = array();

		/* now, check if we've got all required fields, visible or hidden */
		foreach ($dst["fields"] AS $field => $props) {
			if ($props["required"] && $props["defaultvalue"] == "" && !in_array($table . "-" . $field, $columns) && !in_array($table . "-" . $field, $columns_hidden)) {
				$missing[] = $table . "-" . $field;
			}
		}

		if (count($missing) > 0) {

			/* we don't have all required fields. stop. */
			if (is_administrator()) {

				return '<tr><td colspan="' . count($columns) . '" class="noclick">Not all required fields are visible. Not showing form. Missing: ' . implode(', ', $missing) . '. Prefill: ' . string_r($prefill) . '</td></tr>';

			} else {

				return '';

			}
		}

		/* counter for checking which element is last */
		$cnt =0;

		/* the tr has an id; all elements within this id will be submitted */
		$row = '<tr class="listaddrow" id="' . $table . '-' . $listid . '-inlineadd">';

		/* walk through $columns (which contains all fqn fieldnames in the shown list) */
		foreach ($columns AS $column) {

			/* determine table & field */
			list($table, $field) = explode("-", $column);

			$row .= '<td';
			if ($dst["fields"][$field]["fieldtype"] == "number") {

				/* add class for numbers */
				$row .= ' class="num"';

			}
			$row .= '>';

			/* don't show primary, timestamp_last_change (all hardcoded fields) and fields the user doesn't have access to */
			if ($field != $dst["primary"] && $field != "timestamp_last_change" && $dst["fields"][$field]["allowed_to_write"]) {

				/* determine classes to add */
				$classes = array();

				if ($dst["fields"][$field]['fieldtype_in_extrafields_table'] != "text area" && $dst["fields"][$field]['fieldtype_in_extrafields_table'] != "text area (rich text)" && !$dst["fields"][$field]["multiline"]) {

					/* do nothing with multiline fields but all others get enter2blur */
					$classes = array("enter2blur");

				}

				/* set the value from the prefill array */
				$value = $prefill_values[$column];

				/* if it's a multiselect ... */
				if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['multiselect']) {

					/* base64_encode it and put it in a serialized array (legacy) */
					$value = serialize(array(base64_encode($value)));
				}

				/* get the form element from the general form element generator */
				$row .= get_form_element($column, $value, "", $classes, true, true);


			} else {

				if ($dst["fields"][$field]["defaultvalue"] != "") {
					/* we're in list, so no escaping. get_parsed_template DOES escaping, so unescape */
					$row .= get_parsed_template_with_given_template($table, "", array(), "", false, "", $dst["fields"][$field]["defaultvalue"], 'DEFAULTVALUE');
				}
				/* for debug purposes, show an html comment when it didn't work out */
				$row .= '<!-- this field is not suitable for user input //-->';
			}

			/* check to see if we're at the last element */
			if ($cnt == count($columns)-1) {

				/* if so, add the extra html to this element */
				$row .= $add_at_end;
			}

			/* close the cell */
			$row .= '</td>';

			/* counter for checking which element is last */
			$cnt++;
		}

		/* add empty cells for extra columns */
		foreach ($custom_extra_columns AS $dummy) {
			unset($dummy);
			$row .= '<td></td>';
		}

		/* close the row */
		//$row .= '<td>' . htme(string_r($_GET)) . '</td>';
		$row .= '</tr>';
	}

	/* return the row DO NOT UNESCAPE */

	//JH resetten ivm eventuele andere calls naar ptrd()
	$GLOBALS['prefill_fields'] = array();

	return $row;
}

?>
