<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * list.php
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 6.2.0.20151223
 *
 **********************************************************************
 */

require "initiate.php";

$GLOBALS["InAdminSection"] = true;


$print_end_html = false;
if ($_GET['graphml'] != 1)
{
	ShowHeaders();
	$print_end_html = true;
}

if (is_administrator())
{
	if ($_GET['graphml'] != 1)
	{
		AdminTabs();
	}

	if ($_GET['searchadmin'] == 1)
	{
		print '<div>';
		print '<form method="get" action="listadmin.php">';
		print '<input type="hidden" name="searchadmin" value="1">';
		print '<input type="search" placeholder="search" name="search" value="' . htme($_GET['search']) . '"> ';
		print '<input type="checkbox" name="whole_word_only" id="whole_word_only" value="1"';
		if ($_GET['whole_word_only'] == 1)
		{
			print ' checked';
		}
		print '> <label for="whole_word_only">whole word only</label> ';
		print '<input type="submit" value="Search whole config">';
		print '</form>';
		print '</div>';

		$name_in_database_openlink = array();
		foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
		{
			if ($GLOBALS['UC']['PersonalDataStructure'][$table]["openlink"] != "")
			{
				$name_in_database_openlink[$GLOBALS['UC']['PersonalDataStructure'][$table]["name_in_database"]] = $GLOBALS['UC']['PersonalDataStructure'][$table]["openlink"];
			}
		}

		$whole_word_only = false;
		if ($_GET['whole_word_only'] == 1)
		{
			$whole_word_only = true;
		}

		$hits = search_all_admin_tables($_GET['search'], $whole_word_only);

		print '<h1>' . count($hits) . ' hits</h1>';
		foreach ($hits as $hit)
		{
			$close_link = false;
			if (preg_match("/^CRM(\w+) \w+\=(\w+)/", $hit, $match))
			{
				if ($name_in_database_openlink[$match[1]] != "")
				{
					print '<a href="' . $name_in_database_openlink[$match[1]] . $match[2] . '">';
					$close_link = true;
				}
//				print '<h1>table = ' . $match[1] . '</h1>';
//				print '<h1>id = ' . $match[2] . '</h1>';
			}
			print htme($hit);
			if ($close_link)
			{
				print '</a>';
			}
			print '<br><br>';
		}
	}

	if ($_GET['renumberfields'] == 1)
	{
		foreach (db_GetFlatArray("SELECT DISTINCT(tabletype) FROM CRMextrafields WHERE deleted='n'") as $tabletype)
		{
			print '<h1>table ' . $tabletype . '</h1>';

			$order = 0;
			foreach (db_GetFlatArray("SELECT id FROM CRMextrafields WHERE tabletype='" . $tabletype . "' AND deleted='n' ORDER BY ordering, id") as $efid)
			{
				$order += 100;
				print '<h2>field ' . $efid . ' = ' . $order . '</h2>';
				mcq("UPDATE CRMextrafields SET timestamp_last_change=timestamp_last_change, ordering=" . $order . " WHERE id=" . $efid);
			}
		}
	}

	if ($_GET['renumbertables'] == 1)
	{
		$order = 0;
		foreach (db_GetFlatArray("SELECT recordid FROM CRMflextabledefs ORDER BY ordering, recordid") as $table_id)
		{
			$order += 100;
			print '<h2>table ' . $table_id . ' = ' . $order . '</h2>';
			mcq("UPDATE CRMflextabledefs SET timestamp_last_change=timestamp_last_change, ordering=" . $order . " WHERE recordid=" . $table_id);
		}
	}

	if ($_GET['dsjson'] == 1)
	{
		$json = '';
		$json .= '{"nodes":[';
		$group = 0;
		$node = 0;
		foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
		{
			if (($GLOBALS['UC']['PersonalDataStructure'][$table]["datatable"]) || ($table == "users") || ($table == "files"))
			{
				if ($node > 0)
				{
					$json .= ',';
				}
				$json .= '{"name":"' . $GLOBALS['UC']['PersonalDataStructure'][$table]["plural"] . '","group":' . $group . '}';
				$GLOBALS['UC']['PersonalDataStructure'][$table]["jsonnode"] = $node;
				$node++;

				foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"]) as $field)
				{
					if ($node > 0)
					{
						$json .= ',';
					}
					$json .= '{"name":"' . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["name"] . '","group":' . $group . '}';
					$GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["jsonnode"] = $node;
					$node++;
				}
				$group++;
			}
		}
		$json .= '],"links":[';
		$links = 0;
		foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
		{
			foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"]) as $field)
			{
				if (isset($GLOBALS['UC']['PersonalDataStructure'][$table]["jsonnode"]))
				{
					$source = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["jsonnode"];
					$target = $GLOBALS['UC']['PersonalDataStructure'][$table]["jsonnode"];
					if ($links > 0)
					{
						$json .= ',';
					}
					$json .= '{"source":' . $source . ',"target":' . $target . ',"value":1}';
					$links++;


					$relation_to_table = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["relation_to"];
					if (($relation_to_table != "") && (isset($GLOBALS['UC']['PersonalDataStructure'][$relation_to_table]["jsonnode"])))
					{
	//					$relation_to_field = $GLOBALS['UC']['PersonalDataStructure'][$relation_to_table]["primary"];
	//					$target = $GLOBALS['UC']['PersonalDataStructure'][$relation_to_table]["fields"][$relation_to_field]["jsonnode"];
						$target = $GLOBALS['UC']['PersonalDataStructure'][$relation_to_table]["jsonnode"];
						
						if ($links > 0)
						{
							$json .= ',';
						}
						$json .= '{"source":' . $source . ',"target":' . $target . ',"value":1}';
						$links++;
					}
/*
					preg_match_all("/\bEFID(\d+)\b/", $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['calculation'], $matches);
					foreach (array_unique($matches[1]) as $efid)
					{
						$relation_to_field = "f" . $efid;
						if ($relation_to_field != $field)
						{
							$relation_to_table = get_ds_tablename_for_field($efid);
							$target = $GLOBALS['UC']['PersonalDataStructure'][$relation_to_table]["fields"][$relation_to_field]["jsonnode"];
							
							if ($links > 0)
							{
								$json .= ',';
							}
							$json .= '{"source":' . $source . ',"target":' . $target . ',"value":2}';
							$links++;
						}
					}
*/
				}
			}
		}

		$json .= ']}';

		print '<textarea>';
		print htme($json);
		print '</textarea>';

	}

	if ($_GET['convertcolors'] == 1)
	{
		$colors = array();
		$css = "";
		foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
		{
			foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"]) as $field)
			{
				$operand = "IS";
				foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"][$operand]) as $value)
				{
					$css .= "." . $operand . "-" . $table . "-" . $field . "-" . $value . "\n";
					$css .= "{\n";
//					pre( $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"][$operand][$value]);
					if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"][$operand][$value]["background"] != "")
					{
						$css .= "\tbackground-color: " . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"][$operand][$value]["background"] . ";\n";

						$colors[$GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"][$operand][$value]["background"]]["fg"] = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"][$operand][$value]["foreground"];
						$colors[$GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"][$operand][$value]["background"]]["comment"] .= $GLOBALS['UC']['PersonalDataStructure'][$table]["plural"] . " " . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["name"] . " " . $operand . " " . $value . " (" . $table . "-" . $field . ")\n";
					}
					if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"][$operand][$value]["foreground"] != "")
					{
						$css .= "\tcolor: " . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["colors"][$operand][$value]["foreground"] . ";\n";
					}
					$css .= "}\n";
				}
			}
		}
//		pre($css);

//		print "-----------------------------";

		$css = "";
		$kleur = 0;
		foreach (array_keys($colors) as $backcolor)
		{
			$kleur++;

			$css .= "/*\n";
			$css .= $colors[$backcolor]["comment"];
			$css .= "*/\n";
			$css .= ".c" . $kleur . "\n";
			$css .= "{\n";
			$css .= "\tbackground-color: " . $backcolor . ";\n";
			if ($colors[$backcolor]["fg"] != "")
			{
				$css .= "\tcolor: " . $colors[$backcolor]["fg"] . ";\n";
			}
			$css .= "}\n";
			$css .= "\n";
		}
		pre($css);

	}

	if ($_GET['tables'] == 1)
	{
		

		$title = "Tables in data structure";
		print '<h1>' . htme($title) . '</h1>';

		foreach (array(true, false) as $option)
		{
			if ($option)
			{
				print '<h2>Data tables</h2>';
			}
			else
			{
				print '<h2>Admin / nondata tables</h2>';
			}
			$total_number_of_records = 0;
			print '<table class="crm crmclick filtertable">';
			print '<thead><tr><th>Table</th><th>Name</th><th class="num">Number of records</th></tr></thead>';
			print '<tbody>';
			foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
			{
				if ($GLOBALS['UC']['PersonalDataStructure'][$table]["datatable"] == $option)
				{
					$number_of_records = db_GetValue("SELECT COUNT(*) FROM `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$table]["name_in_database"] . "`");
					print '<tr onclick="window.location.href=\'list.php?table=' . $table . '\'"><td>' . $table . '</td><td>' . htme($GLOBALS['UC']['PersonalDataStructure'][$table]["plural"]) . '</td><td class="num">' . FormatNumber($number_of_records, 0, 0, true) . '</td></tr>';
					$total_number_of_records += $number_of_records;
				}
			}
			print '</tbody>';
			print '<tfoot><tr><td></td><td></td><td class="num">' . FormatNumber($total_number_of_records, 0, 0, true) . '</td></tr></tfoot>';
			print '</table>';
		}
	}
	else if ($_GET['duplicategroup'] == 1)
	{


		$title = "Duplicate group";
		print '<h1>' . htme($title) . '</h1>';

		print '<form method="post" action="listadmin.php?duplicategroup=1" onsubmit="return confirm(\'Are you sure?\')">';
		print '<select name="oldgroup_id">';
		print '<option></option>';
		foreach (db_GetArray("SELECT id, name FROM `CRMuserprofiles` WHERE `active`='yes'") as $group)
		{
			print '<option value="' . $group['id'] . '">' . htme($group['name']) . '</option>';
		}
		print '</select> ';
		print '<input type="text" name="newgroup_name" placeholder="new group name"> ';
		print '<input type="submit" value="Duplicate group">';
		print '</form>';

		$oldgroup_id = $_POST['oldgroup_id'];
		$newgroup_name = $_POST['newgroup_name'];


		if ((is_positive_integer($oldgroup_id)) && ($newgroup_name != ""))
		{
//			print "oldgroup_id: " . $oldgroup_id . "<br>";
//			print "newgroup_name: " . $newgroup_name . "<br>";

			$oldgroup = db_GetRow("SELECT * FROM `CRMuserprofiles` WHERE `id`=" . $oldgroup_id . " AND `active`='yes'");
			if ($oldgroup['id'] > 0)
			{
				$oldgroup['name'] = $newgroup_name;

				$sql1 = "INSERT INTO `CRMuserprofiles` (";
				$sql2 = " VALUES (";
				$tel = 0;
				foreach (array_keys($oldgroup) as $field)
				{
					//numeric check want ieder database element staat er ook in als nummer
					if ((!is_numeric($field)) && ($field != "id") && ($field != "timestamp_last_change"))
					{
						if ($tel > 0)
						{
							$sql1 .= ", ";
							$sql2 .= ", ";
						}
						$sql1 .= "`" . $field . "`";
						$sql2 .= "'" . mres($oldgroup[$field]) . "'";
						$tel++;
					}
				}
				$sql1 .= ")";
				$sql2 .= ")";

				$sql = $sql1 . $sql2;
				print '<pre>' . htme($sql) . '</pre>';
				mcq($sql);
				$newgroup_id = db_GetInsertId();

				$sql = "INSERT INTO `CRMattributes` (SELECT " . $newgroup_id . ", 'group', `attribute`, `value`, NOW(), `allowed_values` FROM `CRMattributes` WHERE `entity`=" . $oldgroup['id'] . " AND `identifier`='group')";
				print '<pre>' . htme($sql) . '</pre>';
				mcq($sql);

				$sql = "INSERT INTO `CRMextendedprivsgroup` (`groupid`, `field`, `value`, `rule`, `operand`, `only_apply_for_field`) (SELECT " . $newgroup_id . ", `field`, `value`, `rule`, `operand`, `only_apply_for_field` FROM `CRMextendedprivsgroup` WHERE `groupid`=" . $oldgroup['id'] . ")";
				print '<pre>' . htme($sql) . '</pre>';
				mcq($sql);

				$sql = "INSERT INTO `CRMtemplateaccessrules` (`description`, `group`, `template`, `read`) (SELECT `description`, " . $newgroup_id . ", `template`, `read` FROM `CRMtemplateaccessrules` WHERE `group`=" . $oldgroup['id'] . ")";
				print '<pre>' . htme($sql) . '</pre>';
				mcq($sql);

				$sql = "INSERT INTO `CRMmoduleaccessrules` (`description`, `group`, `module`, `execute`) (SELECT `description`, " . $newgroup_id . ", `module`, `execute` FROM `CRMmoduleaccessrules` WHERE `group`=" . $oldgroup['id'] . ")";
				print '<pre>' . htme($sql) . '</pre>';
				mcq($sql);

				$sql = "INSERT INTO `CRMtableaccessrules` (`description`, `group`, `table`, `read`, `write`, `add`, `delete`) (SELECT `description`, " . $newgroup_id . ", `table`, `read`, `write`, `add`, `delete` FROM `CRMtableaccessrules` WHERE `group`=" . $oldgroup['id'] . ")";
				print '<pre>' . htme($sql) . '</pre>';
				mcq($sql);

				$sql = "INSERT INTO `CRMfieldaccessrules` (`description`, `group`, `field`, `read`, `write`) (SELECT `description`, " . $newgroup_id . ", `field`, `read`, `write` FROM `CRMfieldaccessrules` WHERE `group`=" . $oldgroup['id'] . ")";
				print '<pre>' . htme($sql) . '</pre>';
				mcq($sql);

				$sql = "INSERT INTO `CRMcalendaraccessrules` (`description`, `group`, `calendar`, `read`) (SELECT `description`, " . $newgroup_id . ", `calendar`, `read` FROM `CRMcalendaraccessrules` WHERE `group`=" . $oldgroup['id'] . ")";
				print '<pre>' . htme($sql) . '</pre>';
				mcq($sql);

				$sql = "INSERT INTO `CRMdownloadrules` (`table`, `group`, `max_rows`) (SELECT `table`, " . $newgroup_id . ", `max_rows` FROM `CRMdownloadrules` WHERE `group`=" . $oldgroup['id'] . ")";
				print '<pre>' . htme($sql) . '</pre>';
				mcq($sql);

				print '<h1>Group duplicate complete</h1>';
				print '<div>First add a user to this new group, then use <a href="listadmin.php?groupcomparison=1&amp;SkipMainNavigation=1&amp;group[]=' . $oldgroup['id'] . '&amp;group[]=' . $newgroup_id . '">group comparison to make sure the two groups are the same</a>.</div>';
				DropPersonalDataStructure();
			}
		}

	}
	else if ($_GET['mergeparents'] == 1)
	{
		

		$title = "Merge parent records";
		print '<h1>' . htme($title) . '</h1>';

		$table = $_POST['table'];
		$from = $_POST['from'];
		$to = $_POST['to'];
		$executequeries = false;
		if ($_POST['executequeries'] == 1)
		{
			$executequeries = true;
		}

		print '<div>Migreer alle childs van de ene naar de andere parent. Doe dit wanneer er een dubbeling in de parents zit. De oude parent wordt gedelete. Queries worden pas gerunt als de vink bij Execute queries staat.</div>';
		print '<form method="post" action="listadmin.php?mergeparents=1">';
		print '<select name="table">';
		print '<option></option>';
		foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table2)
		{
			print '<option value="' . $table2 . '"';
			if ($table == $table2)
			{
				print ' selected';
			}
			print '>' . $table2 . ' - ' . htme($GLOBALS['UC']['PersonalDataStructure'][$table2]["plural"]) . '</option>';
		}
		print '</select> ';
		print '<input type="text" name="from" placeholder="from primary key" value="' . htme($from) . '"> ';
		print '<input type="text" name="to" placeholder="to primary key" value="' . htme($to) . '"> ';
		print '<input type="checkbox" name="executequeries" id="executequeries" value="1"> <label for="executequeries">Execute queries</label> ';
		print '<input type="submit">';
		print '</form>';

		if ((is_array($GLOBALS['UC']['PersonalDataStructure'][$table])) && (is_positive_integer($from)) && (is_positive_integer($to)))
		{
			print '<h2>From: ' . $from . ' - ' . htme(get_refer_layout_for_record($table, $from)) . '</h2>';
			print '<h2>To: ' . $to . ' - ' . htme(get_refer_layout_for_record($table, $to)) . '</h2>';
			
			$total_updates = 0;
			
			foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["childs"]) as $child_table)
			{
				foreach ($GLOBALS['UC']['PersonalDataStructure'][$table]["childs"][$child_table] as $child_field)
				{
					$sql = "UPDATE `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$child_table]["name_in_database"] . "` SET `timestamp_last_change`=`timestamp_last_change`, `" . $GLOBALS['UC']['PersonalDataStructure'][$child_table]["fields"][$child_field]["name_in_database"] . "`=" . $to . " WHERE `" . $GLOBALS['UC']['PersonalDataStructure'][$child_table]["fields"][$child_field]["name_in_database"] . "`=" . $from . ";";
					
					$sql .= " -- " . $GLOBALS['UC']['PersonalDataStructure'][$child_table]["plural"] . " " . $GLOBALS['UC']['PersonalDataStructure'][$child_table]["fields"][$child_field]["name"];
					
					print '<pre>' . htme($sql) . '</pre>';
					$updates = db_GetValue("SELECT COUNT(*) FROM `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$child_table]["name_in_database"] . "` WHERE `" . $GLOBALS['UC']['PersonalDataStructure'][$child_table]["fields"][$child_field]["name_in_database"] . "`=" . $from);
					$total_updates += $updates;
					print '<div>Rows to update: ' . $updates . '</div>';
					if ($executequeries)
					{
						mcq($sql);
					}
				}
			}
			$sql = "DELETE FROM `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$table]["name_in_database"] . "` WHERE `" . $GLOBALS['UC']['PersonalDataStructure'][$table]["primary"] . "`=" . $from . ";";
			print '<pre>' . htme($sql) . '</pre>';
			$updates = db_GetValue("SELECT COUNT(*) FROM `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$table]["name_in_database"] . "` WHERE `" . $GLOBALS['UC']['PersonalDataStructure'][$table]["primary"] . "`=" . $from);
			$total_updates += $updates;
			print '<div>Rows to update: ' . $updates . '</div>';

			if ($executequeries)
			{
				mcq($sql);
			}
			
			print '<h2>Total updates: ' . $total_updates . '</h2>';

			if ($executequeries)
			{
				print '<h2>Queries have been run</h2>';
			}
		}
	}
	else if ($_GET['groupcomparison'] == 1)
	{
	

		$title = "Group comparison";
		print '<h1>' . htme($title) . '</h1>';

		$only_table = $_GET['table'];
		$only_field = $_GET['field'];
		//erg lomp dit om de tabel te vinden
		if (preg_match("/f(\d+)$/", $only_field, $match))
		{
			$only_table = get_ds_tablename_for_field($match[1]);
		}
		$field_displayed = false;

//niet nodig toch? ik ben admin
//		$SystemDataStructure = GetSystemDataStructure();
		$UserDataStructures = array();
		$UserDataStructure_restrictions = array();

		$curent_user = $GLOBALS['USERID'];
		$all_groups = db_GetArray("SELECT * FROM CRMuserprofiles WHERE active='yes' ORDER BY name");
		$groups = array();

		print '<form method="get" action="">';
		print '<input type="hidden" name="groupcomparison" value="1">';
		print '<input type="hidden" name="SkipMainNavigation" value="1">';
		foreach ($all_groups as $group)
		{
			print '<div><input type="checkbox" name="group[]" value="' . $group["id"] . '" id="group' . $group["id"] . '"';
			if ((in_array($group["id"], $_GET['group'])) || ($only_table != ""))
			{
				$groups[] = $group;
				print ' checked';
			}
			print '> <label for="group' . $group["id"] . '">' . htme($group["name"]) . '</label></div>';
		}
		print '<input type="submit">';
		print '</form>';



		print '<div class="hidethesame">';
		print '<input type="checkbox" id="showthesame"> show settings that are the same for all groups';

		print '<table class="sortable groupcomparison">';
		print '<thead>';
		print '<tr>';
		print '<th>Item</th>';
		foreach ($groups as $group)
		{
			$example_user = db_GetRow("SELECT id, FULLNAME FROM CRMloginusers WHERE PROFILE=" . $group['id'] . " AND active='yes' ORDER BY id");
			if ($example_user['id'] == 0)
			{
				 $example_user['FULLNAME'] = "NO ACTIVE USERS IN THIS GROUP";
			}
			
			print '<th>' . htme($group["name"] . ' (' . $example_user['FULLNAME']) . ')</th>';
			//profiel zonder users
			if ($example_user['id'] > 0)
			{
				InitUser($example_user['id']);
				$UserDataStructures[$group['id']] = get_data_structure();

				foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
				{
//					if (($GLOBALS['UC']['PersonalDataStructure'][$table]["datatable"]) && (is_array($UserDataStructures[$group['id']][$table])))
					if (is_array($UserDataStructures[$group['id']][$table]))
					{
						$UserDataStructure_restrictions[$group['id']][$table]["read"]["sql"] = get_recursive_access_querypart($table, "", "read", array(), false);
						$UserDataStructure_restrictions[$group['id']][$table]["write"]["sql"] = get_recursive_access_querypart($table, "", "write", array(), false);

						$UserDataStructure_restrictions[$group['id']][$table]["read"]["html"] = get_recursive_access_querypart($table, "", "read", array(), true);
						$UserDataStructure_restrictions[$group['id']][$table]["write"]["html"] = get_recursive_access_querypart($table, "", "write", array(), true);
					}
				}
			}
		}
		InitUser($curent_user);
/*
		print '<pre>';
		print_r($UserDataStructure_restrictions);
		print '</pre>';
*/

		print '</tr>';
		print '</thead>';
		print '<tbody>';
		//wij zijn admin dus in PersonalDataStructure zitten alle tabellen
		$total_compared = 0;
		$total_allthesame = 0;
		foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
		{
			if (($only_table != "") && ($only_table != $table))
			{
				continue;
			}

//			if ($GLOBALS['UC']['PersonalDataStructure'][$table]["datatable"])
			{
				$access = array();

				$diff = array();
				$tmp = '';
				foreach ($groups as $group)
				{
					$class = 'noaccess';
					$query = '';
					$acc = 0;
					if (is_array($UserDataStructures[$group['id']][$table]))
					{
						$query = $UserDataStructure_restrictions[$group['id']][$table]["read"]["sql"];
						if ($query == "")
						{
							$class = 'fullaccess';
							$acc = 2;
						}
						else
						{
							$class = 'limitedaccess';
							$acc = 1;
						}
					}
					$tmp .= '<td class="' . $class . '" title="' . htme($query) . '">' . $UserDataStructure_restrictions[$group['id']][$table]["read"]["html"] . '</td>';
					$diff[$class . " " . $UserDataStructure_restrictions[$group['id']][$table]["read"]["html"]]++;

					$access[$group['id']]["read"] = $acc;
				}

				$total_compared++;
				print '<tr';
				if (count($diff) == 1)
				{
					$total_allthesame++;
					print ' class="allthesame"';
				}				
				print '>';
				print '<td>';
				if (preg_match("/^t(\d+)$/", $table, $match))
				{
					print '<a href="flextable.php?EditFlexTable=' . $match[1] . '">';
				}
				print htme('Table ' . $table . ' ' . $GLOBALS['UC']['PersonalDataStructure'][$table]["plural"]);
				if (preg_match("/^t(\d+)$/", $table, $match))
				{
					print '</a>';
				}
				print ' readable</td>';
				print $tmp;
				print '</tr>';

				foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"]) as $field)
				{
					if (($only_field != "") && ($only_field != $field))
					{
						continue;
					}

					$diff = array();
					$tmp = '';

					foreach ($groups as $group)
					{
						$class = 'noaccess';
						if (is_array($UserDataStructures[$group['id']][$table]["fields"][$field]))
						{
							$class = 'fullaccess';
						}
						$tmp .= '<td class="' . $class . '"></td>';
						$diff[$class]++;
					}
					$total_compared++;
					print '<tr';
					if (count($diff) == 1)
					{
						$total_allthesame++;
						print ' class="allthesame"';
					}
					print '>';
					print '<td>';
					if (preg_match("/^f(\d+)$/", $field, $match))
					{
						print '<a href="extrafields.php?editextrafield=' . $match[1] . '">';
					}
					print htme('Table ' . $table . ' ' . $GLOBALS['UC']['PersonalDataStructure'][$table]["plural"] . ' field ' . $field . ' ' . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["name"]);
					if (preg_match("/^f(\d+)$/", $field, $match))
					{
						print '</a>';
					}
					print ' readable</td>';
					print $tmp;
					print '</tr>';


					$diff = array();
					$tmp = '';
					foreach ($groups as $group)
					{
						$class = 'noaccess';
						if ($UserDataStructures[$group['id']][$table]["fields"][$field]["interactive"])
						{
							$class = 'fullaccess';
						}
						$tmp .= '<td class="' . $class . '"></td>';
						$diff[$class]++;
					}
					$total_compared++;
					print '<tr';
					if (count($diff) == 1)
					{
						$total_allthesame++;
						print ' class="allthesame"';
					}
					print '>';
					print '<td>';
					print htme('Table ' . $table . ' ' . $GLOBALS['UC']['PersonalDataStructure'][$table]["plural"] . ' field ' . $field . ' ' . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["name"]);
					print ' interactive</td>';
					print $tmp;
					print '</tr>';
				}


				$diff = array();
				$tmp = '';
				foreach ($groups as $group)
				{
					$class = 'noaccess';
					$query = '';
					$html = '';
					$acc = 0;
					if ((is_array($UserDataStructures[$group['id']][$table])) && ($UserDataStructures[$group['id']][$table]["allowed_to_write"]))
					{
						//zowel read als write moeten geen security restricties hebben voordat ALLE records in deze tabel writeable zijn
						if (($UserDataStructure_restrictions[$group['id']][$table]["read"]["sql"] == "") && ($UserDataStructure_restrictions[$group['id']][$table]["write"]["sql"] == ""))
						{
							$class = 'fullaccess';
							$acc = 2;
						}
						else
						{
							$class = 'limitedaccess';
							foreach (array("read", "write") as $lus)
							{
								$sql = $UserDataStructure_restrictions[$group['id']][$table][$lus]["sql"];
								if ($sql != "")
								{
									if ($query != "")
									{
										$query .= " AND ";
										$html .= '<br>';
									}
									$query .= $sql;
									$html .= $UserDataStructure_restrictions[$group['id']][$table][$lus]["html"];
								}
							}

							$acc = 1;
						}
					}
					$tmp .= '<td class="' . $class . '" title="' . htme($query) . '">' . $html . '</td>';
					$diff[$class . " " . $html]++;

					$access[$group['id']]["write"] = $acc;
				}

				$total_compared++;
				print '<tr';
				if (count($diff) == 1)
				{
					$total_allthesame++;
					print ' class="allthesame"';
				}
				print '>';
				print '<td>';
				if (preg_match("/^t(\d+)$/", $table, $match))
				{
					print '<a href="flextable.php?EditFlexTable=' . $match[1] . '">';
				}
				print htme('Table ' . $table . ' ' . $GLOBALS['UC']['PersonalDataStructure'][$table]["plural"]);
				if (preg_match("/^t(\d+)$/", $table, $match))
				{
					print '</a>';
				}
				print ' writeable</td>';
				print $tmp;
				print '</tr>';


				foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"]) as $field)
				{
					if (($only_field != "") && ($only_field != $field))
					{
						continue;
					}
					
					$diff = array();
					$tmp = '';
					foreach ($groups as $group)
					{
						$class = 'noaccess';
						if ((is_array($UserDataStructures[$group['id']][$table]["fields"][$field])) && ($UserDataStructures[$group['id']][$table]["fields"][$field]["allowed_to_write"]))
						{
							$class = 'fullaccess';
						}
						$tmp .= '<td class="' . $class . '"></td>';
						$diff[$class]++;
					}

					$total_compared++;
					print '<tr';
					if (count($diff) == 1)
					{
						$total_allthesame++;
						print ' class="allthesame"';
					}				
					print '>';
					print '<td>';
					if (preg_match("/^f(\d+)$/", $field, $match))
					{
						print '<a href="extrafields.php?editextrafield=' . $match[1] . '">';
					}
					print htme('Table ' . $table . ' ' . $GLOBALS['UC']['PersonalDataStructure'][$table]["plural"] . ' field ' . $field . ' ' . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["name"]);
					if (preg_match("/^f(\d+)$/", $field, $match))
					{
						print '</a>';
					}
					print ' writeable</td>';
					print $tmp;
					print '</tr>';
				}
			}
		}

		if ($only_table == "")
		{
			foreach (db_GetArray("SELECT `mid`, `module_name` FROM `CRMmodules` WHERE `version_belonging_to`=0 ORDER BY `mid`") as $module)
			{
				$diff = array();
				$tmp = '';
				foreach ($groups as $group)
				{
					$class = 'noaccess';
					//TODO dit moet gebruik maken van CheckModuleAccess()
					if ((db_GetValue("SELECT COUNT(*) FROM `CRMmoduleaccessrules` WHERE `module`=" . $module['mid']) == 0) || (db_GetValue("SELECT COUNT(*) FROM `CRMmoduleaccessrules` WHERE `module`=" . $module['mid'] . " AND `group`=" . $group["id"] . " AND `execute`='1'") > 0))
					//if (CheckModuleAccess($module['mid']) == "ok")
					{
						$class = 'fullaccess';
					}
					$diff[$class]++;
					$tmp .= '<td class="' . $class . '"></td>';
				}

				$total_compared++;
				print '<tr';
				if (count($diff) == 1)
				{
					$total_allthesame++;
					print ' class="allthesame"';
				}
				print '>';
				print '<td><a href="modules.php?action=edit&amp;mid=' . $module['mid'] . '">Module ' . $module['mid'] . ': ' . htme($module['module_name']) . '</a></td>';
				print $tmp;
				print '</tr>';
			}

			foreach (db_GetArray("SELECT `templateid`, `templatename` FROM `CRMtemplates` WHERE `version_belonging_to`=0 ORDER BY `templateid`") as $template)
			{
				$diff = array();
				$tmp = '';
				foreach ($groups as $group)
				{
					$class = 'noaccess';
					//TODO dit moet gebruik maken van CheckTemplateAccess()
					if ((db_GetValue("SELECT COUNT(*) FROM `CRMtemplateaccessrules` WHERE `template`=" . $template['templateid']) == 0) || (db_GetValue("SELECT COUNT(*) FROM `CRMtemplateaccessrules` WHERE `template`=" . $template['templateid'] . " AND `group`=" . $group["id"] . " AND `read`='1'") > 0))
					{
						$class = 'fullaccess';
					}
					$diff[$class]++;
					$tmp .= '<td class="' . $class . '"></td>';
				}

				$total_compared++;
				print '<tr';
				if (count($diff) == 1)
				{
					$total_allthesame++;
					print ' class="allthesame"';
				}
				print '>';
				print '<td><a href="admin.php?templates=1&editHTMLtemplate=' . $template['templateid'] . '">Template ' . $template['templateid'] . ': ' . htme($template['templatename']) . '</a></td>';
				print $tmp;
				print '</tr>';
			}


			foreach (db_GetArray("SELECT `templateid`, `templatename`, `content` FROM `CRMtemplates` WHERE `version_belonging_to`=0 ORDER BY `templateid`") as $template)
			{
				$diff = array();
				$tmp = '';
				foreach ($groups as $group)
				{
					$class = 'fullaccess';
					$txt = '';
					if ((strstr($template['content'], "@GROUP" . $group['id'] . "ONLY@")) || (strstr($template['content'], "@ENDGROUP" . $group['id'] . "ONLY@")))
					{
						$class = 'limitedaccess';
						$txt .= '@GROUP' . $group['id'] . 'ONLY@ tag in template ';
					}
					if ((strstr($template['content'], "@GROUP" . $group['id'] . "NOT@")) || (strstr($template['content'], "@GROUP" . $group['id'] . "NOT@")))
					{
						$class = 'limitedaccess';
						$txt .= '@GROUP' . $group['id'] . 'NOT@ tag in template ';
					}
					$diff[$class]++;

					$tmp .= '<td class="' . $class . '">' . $txt . '</td>';
				}

				$total_compared++;
				print '<tr';
				if (count($diff) == 1)
				{
					$total_allthesame++;
					print ' class="allthesame"';
				}
				print '>';
				print '<td><a href="admin.php?templates=1&amp;editHTMLtemplate=' . $template['templateid'] . '">Template ' . $template['templateid'] . ': ' . htme($template['templatename']) . '</a></td>';
				print $tmp;
				print '</tr>';
			}

			$generals = array();
			foreach ($groups as $group)
			{
				$val = "yes";
				if ($group['HIDEFROMASSIGNEEANDOWNERLISTS'] == "y")
				{
					$val = "no";
				}
				$generals["General - Visible in user lists"][$group['id']] = $val;
				
				$cllevel = unserialize($group['CLLEVEL']);
				
				$val = "no";
				if (in_array("MaySelectColumns", $cllevel))
				{
					$val = "yes";
				}
				$generals["General - Column selection"][$group['id']] = $val;
				
				$val = "no";
				if (in_array("AddEditSelections", $cllevel))
				{
					$val = "yes";
				}
				$generals["General - Selections add/edit"][$group['id']] = $val;
				
				$val = "yes";
				if (in_array("HideUserNames", $cllevel))
				{
					$val = "no";
				}
				$generals["General - Usernames visisble"][$group['id']] = $val;

				$val = "yes";
				if (in_array("DenyJournalAccess", $cllevel))
				{
					$val = "no";
				}
				$generals["General - View journals (all)"][$group['id']] = $val;

				$val = "no";
				if (in_array("ShowOnlyOwnJournalRecords", $cllevel))
				{
					$val = "yes";
				}
				$generals["General - View journals (only own)"][$group['id']] = $val;
				
				$val = "yes";
				if (in_array("HideListExportIcons", $cllevel))
				{
					$val = "no";
				}
				$generals["General - Downloads (global)"][$group['id']] = $val;

				$val = "no";
				if (in_array("AllowedToExportXML", $cllevel))
				{
					$val = "yes";
				}
				$generals["General - Downloads XML (global)"][$group['id']] = $val;
				
				$val = "yes";
				if (in_array("DontEditOwnProfile", $cllevel))
				{
					$val = "no";
				}
				$generals["General - Edit own profile"][$group['id']] = $val;
				
				$val = "no";
				if (in_array("UserAdmin", $cllevel))
				{
					$val = "yes";
				}
				$generals["General - User admin"][$group['id']] = $val;

				$val = "no";
				if (in_array("UserAdminSudo", $cllevel))
				{
					$val = "yes";
				}
				$generals["General - User admin login-as"][$group['id']] = $val;

				$val = "no";
				if (in_array("SendMessagesToAllUsers", $cllevel))
				{
					$val = "yes";
				}
				$generals["General - Allowed to send messages to all users at once"][$group['id']] = $val;

				$val = "no";
				if (in_array("AllowedToAlterDiaryContents", $cllevel))
				{
					$val = "yes";
				}
				$generals["General - Change and delete previously added diary remarks (other users)"][$group['id']] = $val;

				$val = "no";
				if (in_array("AllowedToAlterOwnDiaryContents", $cllevel))
				{
					$val = "yes";
				}
				$generals["General - Change and delete previously added diary remarks (own)"][$group['id']] = $val;

				$val = "no";
				if (in_array("requiretpa", $cllevel))
				{
					$val = "yes";
				}
				$generals["General - Two-phase authentication"][$group['id']] = $val;

				$dashboard_id = $group['DASHBOARDFILEID'];
				if ($dashboard_id == 0)
				{
					$dashboard_id = GetSetting("DASHBOARDTEMPLATE");
				}
				$generals["General - Dashboard"][$group['id']] = $dashboard_id . " " . db_GetValue("SELECT templatename FROM CRMtemplates WHERE templateid='" . mres($dashboard_id) . "'");

				$tmp = str_replace("t-", "", $group['MENUTOUSE']);
				$generals["General - Menu"][$group['id']] = $tmp . " " . db_GetValue("SELECT templatename FROM CRMtemplates WHERE templateid='" . mres($tmp) . "'");
			}

			foreach (array_keys($generals) as $general)
			{
				$diff = array();
				$tmp = '';
				foreach ($groups as $group)
				{
					$diff[$generals[$general][$group['id']]]++;
					$tmp .= '<td';
					if ($generals[$general][$group['id']] == "no")
					{
						$tmp .= ' class="noaccess"';
					}
					else if ($generals[$general][$group['id']] == "yes")
					{
						$tmp .= ' class="fullaccess"';
					}
					$tmp .= '>';
					if (($generals[$general][$group['id']] != "yes") && ($generals[$general][$group['id']] != "no"))
					{
						$tmp .= htme($generals[$general][$group['id']]);
					}
					$tmp .= '</td>';
				}
				$total_compared++;
				print '<tr';
				if (count($diff) == 1)
				{
					$total_allthesame++;
					print ' class="allthesame"';
				}
				print '>';
				print '<td>' . $general . '</td>';
				print $tmp;
				print '</tr>';
			}
		}
		
		print '</tbody>';
		print '</table>';

		print '<h3>Total settings compared: ' . $total_compared . '</h3>';
		print '<h3>Total settings the same: ' . $total_allthesame . '</h3>';
		print '<h3>Total settings different: ' . ($total_compared - $total_allthesame) . '</h3>';


		if (($only_field != "") && ($field_displayed == false))
		{
			print '<div><br><strong>Field "' . $only_field . '" has same access rights as table "' . $only_table . '".</strong></div>';
		}
	}

	else if ($_GET['fieldcomparison'] == 1)
	{
		

		$title = "Field comparison";
		print '<h1>' . htme($title) . '</h1>';

		$allkeys = array();
		foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
		{
			foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"]) as $field)
			{
				foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]) as $key)
				{
					if (!in_array($key, $allkeys))
					{
						$allkeys[] = $key;
					}
				}
			}
		}

		print '<table class="crm noclick sortable filtertable">';
		print '<thead>';
		print '<tr>';
		print '<th>table</th>';
		print '<th>table plural</th>';
		print '<th>field</th>';
		foreach ($allkeys as $key)
		{
			print '<th>' . $key . '</th>';
		}
		print '</tr>';
		print '</thead>';
		print '<tbody>';
		foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
		{
			foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"]) as $field)
			{
				print '<tr>';
				print '<td>' . htme($table) . '</td>';
				print '<td>' . htme($GLOBALS['UC']['PersonalDataStructure'][$table]["plural"]) . '</td>';
				print '<td>' . htme($field) . '</td>';
				foreach ($allkeys as $key)
				{
					print '<td>';
					if (is_array($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field][$key]))
					{
						if (count($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field][$key]) > 0)
						{
							print '<pre>';
							print_r($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field][$key]);
							print '</pre>';
						}
					}
					else
					{
						print htme($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field][$key]);
					}
					print '</td>';
				}
				print '</tr>';
			}
		}
		print '</tbody>';
		print '</table>';
	}

	else if ($_GET['tablecomparison'] == 1)
	{
		

		$title = "Table comparison";
		print '<h1>' . htme($title) . '</h1>';

		//plural wel
		//allowed_to_add we zijn admin dus niet interessant
		$skip_settings = array("datatable", "layout", "primary", "name_in_database", "openlink", "addlink", "allow_direct_view", "default_sortby", "default_sortdirection", "singular", "addlinktext", "allowed_to_add", "headerhtml", "download_allowed", "MaySelectColumns");
		$ds_settings = array();
		foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
		{
			//we zoeken de eerst bestaande flextable
			if ((preg_match("/^t\d+$/", $table)) && (count($ds_settings) == 0))
			{
				//$ds_settings = array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]);
				foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]) as $ds_setting)
				{
					if ((!is_array($GLOBALS['UC']['PersonalDataStructure'][$table][$ds_setting])) && (!in_array($ds_setting, $skip_settings)))
					{
						$ds_settings[] = $ds_setting;
					}
				}
			}
		}

		print '<table class="crm noclick sortable filtertable">';
		print '<thead>';
		print '<tr>';
		print '<th>Table</th>';
		foreach ($ds_settings as $ds_setting)
		{
			print '<th>' . htme($ds_setting) . '</th>';
		}
		print '</tr>';
		print '</thead>';
		print '<tbody>';
		foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
		{
			if ($GLOBALS['UC']['PersonalDataStructure'][$table]["datatable"])
			{
				print '<tr>';
				print '<td>' . htme($table . ' ' . $GLOBALS['UC']['PersonalDataStructure'][$table]["plural"]) . '</td>';
				foreach ($ds_settings as $ds_setting)
				{
					$value = $GLOBALS['UC']['PersonalDataStructure'][$table][$ds_setting];
					$class = get_pastel_color_by_hash($value);
					print '<td style="background-color: #' . $class . ';">' . htme($value) . '</td>';
				}
				print '</tr>';
			}
		}
		print '</tbody>';
		print '</table>';
	}
	else if ($_GET['datastructuregraphic'] == 1)
	{
		

		$title = "Graphic data structure";
		print '<h1>' . htme($title) . '</h1>';

		// HF20150507 Support voor show_admintables=1 ingebouwd
		$show_datatables = true;
		$show_usertable = true;
		$show_grouptable = true;
		$show_admintables = false;
		if ($_GET['showadmintables'] == 1) {
			$show_admintables = true;
		}
		print directed_graph_data_schema($show_datatables, $show_usertable, $show_grouptable, $show_admintables);

		print '<h2>Graphml download</h2>';
		print '<form method="get" action="listadmin.php">';
		print '<input type="hidden" name="graphml" value="1">';
		print '<input type="hidden" name="SkipMainNavigation" value="">';
		print '<div><input type="checkbox" name="graphmldatatable" value="yes" id="graphmldatatable" checked> <label for="graphmldatatable">show data tables</label></div>';
		print '<div><input type="checkbox" name="graphmlusertable" value="yes" id="graphmlusertable"> <label for="graphmlusertable">show user and group tables</label></div>';
		print '<div><input type="checkbox" name="graphmladmintable" value="yes" id="graphmladmintable"> <label for="graphmladmintable">show admin tables</label></div>';
		print '<div><input type="checkbox" name="graphmltechnicalname" value="yes" id="graphmltechnicalname" checked> <label for="graphmltechnicalname">show technical names (e.g. t15 or f23)</label></div>';
		print '<div><input type="checkbox" name="graphmlhumanname" value="yes" id="graphmlhumanname" checked> <label for="graphmlhumanname">show human names (e.g. Orders or Customer)</label></div>';
		print '<div><input type="submit" value="Download xml"></div>';
		print '</form>';


		print '<div><a href="listadmin.php?datastructuregraphic=1&amp;SkipMainNavigation&amp;showadmintables=1">Show admin tables as well</a></div>';

		$maxdepth = 0;
		$tabledepth = array();
		foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
		{
			if (($GLOBALS['UC']['PersonalDataStructure'][$table]["datatable"]) || ($_GET['showadmintables'] == 1))
			{
				$depth = get_table_depth($table);
				$tabledepth[$table] = $depth;
				if ($depth > $maxdepth)
				{
					$maxdepth = $depth;
				}
			}
		}

		$number_of_child_tables = array();
		$number_of_parent_tables = array();
		foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
		{
			if (($GLOBALS['UC']['PersonalDataStructure'][$table]["datatable"]) || ($_GET['showadmintables'] == 1))
			{
				$number_of_parent_tables[$table] = 0;
				$number_of_child_tables[$table] = 0;
			}
		}

		foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
		{
			if (($GLOBALS['UC']['PersonalDataStructure'][$table]["datatable"]) || ($_GET['showadmintables'] == 1))
			{
				foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"]) as $field)
				{
					$relation_to = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["relation_to"];
					if ($relation_to != "")
					{
						$number_of_parent_tables[$table]++;
						$number_of_child_tables[$relation_to]++;
					}
				}
			}
		}

		$tablecolors = array();
		foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
		{
			if (($GLOBALS['UC']['PersonalDataStructure'][$table]["datatable"]) || ($_GET['showadmintables'] == 1))
			{
				$tablecolors[$table] = get_pastel_color_by_hash($table);
			}
		}

/*
		$js = "";
		$link = 0;
		for ($x = 0; $x <= $maxdepth; $x++)
		{
			foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
			{
				if ($tabledepth[$table] == $x)
				{
					//if (($GLOBALS['UC']['PersonalDataStructure'][$table]["datatable"]) || ($_GET['showadmintables'] == 1))
					if (($GLOBALS['UC']['PersonalDataStructure'][$table]["datatable"]) || ($table == "users") || ($table == "groups"))
					{
						print '<div style="margin: 10px; border: 1px solid #000; padding: 5px; display: inline-block" id="container' . $table . '">' . htme($GLOBALS['UC']['PersonalDataStructure'][$table]["plural"]) . '</div>';

						foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"]) as $field)
						{
							$relation_to = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["relation_to"];
							if ($relation_to != "")
							{
								$link++;
								$source = "e" . $table . $link;
								$js .= "var " . $source . " = jsPlumb.addEndpoint('container" . $table . "');\n";

								$link++;
								$target = "e" . $relation_to . $link;
								$js .= "var " . $target . " = jsPlumb.addEndpoint('container" . $relation_to . "');\n";

								$js .= "jsPlumb.connect({ source:" . $source . ", target:" . $target . " });\n";
							}
						}
					}
				}
			}
			print '<div class="clear: both;">&nbsp;</div>';
		}

print '<script src="https://jsplumbtoolkit.com/js/dom.jsPlumb-1.7.0-min.js"></script>';
print '<script type="text/javascript">';
print 'jsPlumb.bind("ready", function() {';
print $js;
print '});';
print '</script>';
*/


		for ($x = 0; $x <= $maxdepth; $x++)
		{
			print '<div>';
			print '<h2>Level ' . ($x + 1) . '</h2>';
			foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
			{
				if ($tabledepth[$table] == $x)
				{
					if (($GLOBALS['UC']['PersonalDataStructure'][$table]["datatable"]) || ($_GET['showadmintables'] == 1))
					{
						print '<div style="display: inline-block; border: 1px solid #000000; margin: 0 8px 8px 0; padding: 3px; font-size: 80%; vertical-align: top; background-color: #' . $tablecolors[$table] . '; border-radius: 6px;">';
						print '<h3>';
						$closetag = false;
						if (preg_match("/^t(\d+)$/", $table, $match))
						{
							print '<a href="flextable.php?EditFlexTable=' . $match[1] . '" style="color: #000000; text-decoration: none;">';
							$closetag = true;
						}
						print htme($table . ' ' . $GLOBALS['UC']['PersonalDataStructure'][$table]["plural"]);
						if ($closetag)
						{
							print '</a>';
						}
						print '</h3>';
						print '<ul style="margin-top: 0; margin-bottom: 0;">';
						print '<li>Number of parent tables: ' . $number_of_parent_tables[$table] . '</li>';
						print '<li>Number of links from child tables: ' . $number_of_child_tables[$table] . '</li>';

						if (table_is_part_of_circular_join($table))
						{
							print '<li>this table is part of a <strong>circular join</strong></li>';
						}
						else if (circular_join_in_parents($table))
						{
							print '<li>this table has a parent that is part of a <strong>circular join</strong></li>';
						}
						print '</ul>';
						print '<ol style="margin-top: 0; margin-bottom: 0;">';
						foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"]) as $field)
						{
							print '<li>';
							$closetag = false;

							if (preg_match("/^f(\d+)$/", $field, $match))
							{
								print '<a href="extrafields.php?editextrafield=' . $match[1] . '" style="color: #000000; text-decoration: none;">';
								$closetag = true;
							}
							print htme($field . ' ' . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["name"]);
							if ($closetag)
							{
								print '</a>';
							}
							$relation_to = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["relation_to"];
							if ($relation_to != "")
							{
								print ' <div style="display: inline-block; margin: 1px 0; border: 1px solid #000000; padding: 2px; background-color: #' . $tablecolors[$relation_to] . '; border-radius: 3px;">';
								if (preg_match("/^t(\d+)$/", $relation_to, $match))
								{
									print '<a href="flextable.php?EditFlexTable=' . $match[1] . '" style="color: #000000; text-decoration: none;">';
									$closetag = true;
								}
								print htme($relation_to . ' ' . $GLOBALS['UC']['PersonalDataStructure'][$relation_to]["plural"]);
								if ($closetag)
								{
									print '</a>';
								}
								print '</div>';
							}
							print '</li>';
						}
						print '</ol>';
						print '</div>';
					}
				}
			}
		}
	}

	else if ($_GET['graphml'] == 1)
	{
		$tables_shown = array();
		$graphml = '';
		$graphml .= '<?xml version="1.0" encoding="UTF-8" standalone="no"?>' . "\n";
		$graphml .= '<graphml xmlns="http://graphml.graphdrawing.org/xmlns" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:y="http://www.yworks.com/xml/graphml" xmlns:yed="http://www.yworks.com/xml/yed/3" xsi:schemaLocation="http://graphml.graphdrawing.org/xmlns http://www.yworks.com/xml/schema/graphml/1.1/ygraphml.xsd">' . "\n";
		$graphml .= '<key for="node" id="d6" yfiles.type="nodegraphics"/>' . "\n";
		$graphml .= '<key attr.name="description" attr.type="string" for="edge" id="d8"/>' . "\n";
		$graphml .= '<key for="edge" id="d9" yfiles.type="edgegraphics"/>' . "\n";
		$graphml .= '<graph edgedefault="directed" id="G">' . "\n";
		foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
		{
			$showtable = false;
			if (($GLOBALS['UC']['PersonalDataStructure'][$table]["datatable"]) && ($_GET['graphmldatatable'] == "yes"))
			{
				$showtable = true;
			}
			if ((!$GLOBALS['UC']['PersonalDataStructure'][$table]["datatable"]) && ($_GET['graphmladmintable'] == "yes"))
			{
				$showtable = true;
			}
			if ((($table == "users") || ($table == "groups")) && ($_GET['graphmlusertable'] == "yes"))
			{
				$showtable = true;
			}

			if ($showtable)
			{
				$tables_shown[$table] = true;
				$names = array();
				if ($_GET['graphmltechnicalname'] == 'yes')
				{
					$names[] = $table;
				}
				if ($_GET['graphmlhumanname'] == 'yes')
				{
					$names[] = $GLOBALS['UC']['PersonalDataStructure'][$table]["plural"];
				}

				$graphml .= '<node id="' . $table . '">';
				$graphml .= '<data key="d6">';
				$graphml .= '<y:ShapeNode>';
				$graphml .= '<y:NodeLabel>' . htme(implode(" ", $names)) . '</y:NodeLabel>';
				$graphml .= '</y:ShapeNode>';
				$graphml .= '</data>';
				$graphml .= '</node>' . "\n";
			}
		}
		$edge = 0;
		foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
		{
			if ($tables_shown[$table])
			{
				foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["parents"]) as $parent_table)
				{
					if ($tables_shown[$parent_table])
					{
						//er kunnen meerdere referenties naar 1 parent liggen vanuit 1 child
						foreach ($GLOBALS['UC']['PersonalDataStructure'][$table]["parents"][$parent_table] as $field)
						{
							$names = array();
							if ($_GET['graphmltechnicalname'] == 'yes')
							{
								$names[] = $table . '-' . $field;
							}
							if ($_GET['graphmlhumanname'] == 'yes')
							{
								$names[] = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["name"];
							}
//							$graphml .= '<edge id="e' . $edge++ . '" source="' . $table . '" target="' . $parent_table . '">';
							$graphml .= '<edge id="e' . $edge++ . '" source="' . $parent_table . '" target="' . $table . '">';
							$graphml .= '<data key="d8"><![CDATA[' . htme(implode(" ", $names)) . ']]></data>';
							$graphml .= '</edge>' . "\n";
						}
					}
				}
			}
		}
		$graphml .= '</graph>' . "\n";
		$graphml .= '</graphml>' . "\n";

		$filename = "datastructure.graphml";
		header("Content-Type: text/xml; charset=UTF-8");
		header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
		print $graphml;
	}

	else if ($_GET['datastructure'] == 1)
	{
	

		$title = "Data structure";
		print '<h1>' . htme($title) . '</h1>';

		print '<div>Size of serialized personal data structure in bytes: <strong>' . strlen(serialize($GLOBALS['UC']['PersonalDataStructure'])) . '</strong></div>';
		print '<div>Size of serialized system data structure in bytes: <strong>' . strlen(serialize(GetSystemDataStructure())) . '</strong></div>';

		print '<pre>';
//		print htme(print_r(get_data_structure_worker(), true));
		print htme(print_r($GLOBALS['UC']['PersonalDataStructure'], true));
		print '</pre>';
	}

	else if ($_GET['lists'] == 1)
	{
		

		$title = "Available lists";
		print '<h1>' . htme($title) . '</h1>';

		print '<h2>System wide lists</h2>';
		print '<ul>';
		foreach (db_Getarray("SELECT attribute FROM CRMattributes WHERE entity=1 AND identifier='system' AND attribute LIKE 'List-layout-%'") as $row)
		{
			list($prefix1, $prefix2, $table, $listname) = explode("-", $row['attribute']);
			$listname = "system-" . $listname;
			if (is_array($GLOBALS['UC']['PersonalDataStructure'][$table]))
			{
				print '<li><a href="list.php?table=' . $table . '&amp;listname=' . rawurlencode($listname) . '">' . htme(implode(' - ', array($GLOBALS['UC']['PersonalDataStructure'][$table]["plural"], $listname))) . '</a></li>';
			}
		}
		print '</ul>';

		print '<h2>User specific lists</h2>';
		print '<ul>';
		foreach (db_Getarray("SELECT entity, attribute FROM CRMattributes WHERE identifier='user' AND attribute LIKE 'List-layout-%'") as $row)
		{
			list($prefix1, $prefix2, $table, $listname) = explode("-", $row['attribute']);
			$listname = "user-" . $listname;
			if (is_array($GLOBALS['UC']['PersonalDataStructure'][$table]))
			{
				print '<li><a href="list.php?table=' . $table . '&amp;listname=' . rawurlencode($listname) . '&amp;userid=' . $row['entity'] . '">' . htme(implode(' - ', array(db_GetValue("SELECT FULLNAME FROM CRMloginusers WHERE id='" . mres($row['entity']) . "'"), $GLOBALS['UC']['PersonalDataStructure'][$table]["plural"], $listname))) . '</a></li>';
			}
		}
		print '</ul>';
	}
}

EndHTML($print_end_html);

?>
