<?php
/* *****************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This scripts serves public files which the whole world is allowed to see
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.0.20161227
 *
 **********************************************************************
*/


/*
 *  This script intentionally bypasses *ALL* security. It doesn't use *ANY* of Interleaves internal structures and systems.
 */

$filename = $_GET['filename'];

/* we bluntly assume the client has the correct file when given a last modification date in the request; this is safe because blobs cannot be changed */
if ($_SERVER['HTTP_IF_MODIFIED_SINCE'] != '') {

	header('HTTP/1.1 304 Not Modified');

} elseif ($filename != '') {
	
	/* configuration */
	require "config/config.inc.php";
	
	/* functions.php inludes all other files */
	require "functions.php";
	
	/* check to see if a repository number was given, if not assume 0 */
	$repository = 0;
	if (ipi($_GET['repository'])) {
		$repository = $_GET['repository'];
	}

	/* connect to and select database */
	$db = db_base_connect($user[$repository], $pass[$repository], $host[$repository], $database[$repository]);
	
	/* fetch the file by filename and type='public' */
	$row = db_GetRow("SELECT CRMbinfiles.filename, CRMbinfiles.filetype, CRMblobs.content, UNIX_TIMESTAMP(CRMblobs.timestamp_last_change) AS lmd FROM CRMbinfiles, CRMblobs WHERE CRMbinfiles.filename='" . mres($filename) . "' AND CRMbinfiles.fileid = CRMblobs.fileid AND CRMbinfiles.type='public'");
	
	if ($row['content'] != '') {

		$content_disposition = "attachment";
		if (preg_match("/^image\//", $row['filetype']))
		{
			$content_disposition = "inline";
		}
		header("Content-Type: " . $row['filetype']);
		header("Content-Disposition: " . $content_disposition . "; filename=\"" . $row['filename'] . "\"");
		header("Last-Modified: " . gmdate('D, d M Y H:i:s', $row['lmd']) . ' GMT');

		/* output binary content */
		print $row['content'];
	
	} else {
		Show404();
	}
	
	/* close connection */
	db_CloseConnection($db);
}

?>